/*************************************
 MapView 1.1
 (C) 2004-2008 Hynek Sladky
 sladky@mujmail.cz
*************************************/
//#define GPS_gonio
#define GPS_linear
// ------------------------------------
// PalmOS standard include files
// ------------------------------------
#include <PalmOS.h>
#include <VFSMgr.h>
// ------------------------------------
// Sony HiRes support
// ------------------------------------
#include <Sony\SonyCLIE.h>
// ------------------------------------
// ZLib de/compression support
// ------------------------------------
#define NOZLIBDEFS
#include "SysZLib.h"
// ------------------------------------
// LZO de/compression support
// ------------------------------------
#include "lzo1x.h"
// ------------------------------------
// MathLib support
// ------------------------------------
#include "MathLib.h"
// ------------------------------------
// application header
// ------------------------------------
#include "MapView.h"
#include "MapFunc.h"
// ------------------------------------
// resources header
// ------------------------------------
#include "MapViewR.h"
// ====================================
// general functions
// ------------------------------------
// Motorola uses swapped bytes (MSB first)
// SwitchBytes
// ------------------------------------
static void SB (void *ptr, UInt16 len) SECT_FUNC;
static void SB (void *ptr, UInt16 len) {
UInt8 c;
UInt16 i;
  i=len/2;
  while (i) {
    c=((UInt8 *)ptr)[i-1];
    ((UInt8 *)ptr)[i-1]=((UInt8 *)ptr)[len-i];
    ((UInt8 *)ptr)[len-i]=c;
    i--;
  }
}
// ------------------------------------
// reinitializing of bitmap variables and structures after change of LCD mode
// ------------------------------------
UInt16 RenewBitmap (UInt8 bpp) {
UInt16 err;
Coord   b_wd, b_ht;
  // basic check
  if (bpp!=8 && bpp!=16) return 0;
  // check for changes
  if (DrawInfo.bitmap!=NULL && (!(MapInfo.MapHeader.version&CompressedFile) || DrawInfo.zip_data!=NULL)) {
    BmpGetDimensions (DrawInfo.bitmap, &b_wd, &b_ht, NULL);
//    if (DrawInfo.bitmap->width==MapInfo.MapHeader.Wx && DrawInfo.bitmap->height==MapInfo.MapHeader.Wy && DrawInfo.bitmap->pixelSize==bpp)
    if (b_wd==MapInfo.MapHeader.Wx && b_wd==MapInfo.MapHeader.Wy && BmpGetBitDepth (DrawInfo.bitmap)==bpp)
      return 0;
  }
  // freeing memory
  if (DrawInfo.bitmap!=NULL) BmpDelete (DrawInfo.bitmap);
  if (DrawInfo.oldbmp!=NULL) BmpDelete (DrawInfo.oldbmp);
  if (DrawInfo.zip_data!=NULL) MemPtrFree (DrawInfo.zip_data);
  // initializing pointers
  DrawInfo.bitmap=DrawInfo.oldbmp=NULL;
  DrawInfo.zip_data=DrawInfo.bitdata=NULL;
  // creating new space
  DrawInfo.bitmap=BmpCreate (MapInfo.MapHeader.Wx, MapInfo.MapHeader.Wy, bpp, NULL, &err);
  if (DrawInfo.bitmap==NULL) return memoryError;
  DrawInfo.bitdata=BmpGetBits (DrawInfo.bitmap);
  // if HiRes mode and no Sony device
  if (LCD.density!=kDensityLow && LCD.sonyHiResRefNum==sysInvalidRefNum) {
    DrawInfo.bitmap=(BitmapType*)BmpCreateBitmapV3 (DrawInfo.oldbmp=DrawInfo.bitmap, LCD.density, DrawInfo.bitdata, NULL);
    if (DrawInfo.bitmap==NULL) return memoryError;
    DrawInfo.bitdata=BmpGetBits (DrawInfo.bitmap);
  }
  // renewing space for decompressing
  if (MapInfo.MapHeader.version&CompressedFile) {
    DrawInfo.zip_data=MemPtrNew (MapInfo.MapHeader.Wx*MapInfo.MapHeader.Wy+12+100);
    if (DrawInfo.zip_data==NULL) return memoryError;
  }
  return 0;
}
// ------------------------------------
// load new map file and execute selected function
//   position check, relative position, center view
// ------------------------------------
Int16 LoadMapFile (UInt8 func) {
Err             err;
colordef        CTable[256];
UInt16          i;
//Char            filename[256];
RGBColorType    newPal[256], color;
Boolean         reloadPal;
UInt8           webSafe4bpp[16]={0x00, 0xE0, 0xDF, 0x19, 0xDE, 0xDD, 0x32, 0xDC, 0xDB, 0xA5, 0xDA, 0xD9, 0xBE, 0xD8, 0xD7, 0xE6};
add_hdr_type    add_hdr;
UInt32          load_size;
Int16           rdi, gdi, bdi, cdi;
FileRef         mapfile;
GPSinfoType     GPSinfo;
MemHandle       hndl;

  MapInfo.valid=false;
  mapfile=0;
  WinEraseWindow ();
  MapInfo.speed_index=MapInfo.ratio1=MapInfo.ratio2=0;
  MapInfo.ratiocount=500;

  // opening file
  if (*MapInfo.curr_map.name) {
    StrCopy (MapInfo.curr_filename, Prefs.str[homedir]);
    StrCat (MapInfo.curr_filename, MapInfo.curr_map.name);
    err = VFSFileOpen (MapInfo.curr_map.volRefNum, MapInfo.curr_filename, vfsModeRead, &mapfile);
    if (err!=errNone) {
      // map file not found using saved volRefNum
      // I'll try find the same name in map list and open it again
      // immediate directory enumeMapInfo.ration
      while (!VFSInfo.DirectoryOK) GetDirEntry (-1);
      // look for mapname to get volRefNum
      rdi=SearchMap (Prefs.str[overviewmap]);
      if (rdi!=-1) {
        MapInfo.curr_map.volRefNum=VFSInfo.maplist[rdi]->volRefNum;
        err = VFSFileOpen (MapInfo.curr_map.volRefNum, MapInfo.curr_filename, vfsModeRead, &mapfile);
      }
      if (err!=errNone) {
        FrmAlert (fileNotFound);
        mapfile=0;
      }
    }
  }
  // preparing default header params
  MapInfo.MapHeader.Wx=MapInfo.MapHeader.Wy=80;
  MapInfo.MapHeader.Nx=(LCD.actual.native.width+79)/80;
  MapInfo.MapHeader.Ny=(LCD.actual.native.height+79)/80;
  CalcRotatedVars ();
  // init additional information
  MemSet (&MapInfo.gridX, sizeof (MapInfo.gridX), 0);
  MemSet (&MapInfo.gridY, sizeof (MapInfo.gridY), 0);
  MemSet (&MapInfo.SuperTile, sizeof (MapInfo.SuperTile), 0);
  MapInfo.GPScount=0;
  if (MapInfo.GPScal) {
    MemHandleFree (MemPtrRecoverHandle (MapInfo.GPScal));
    MapInfo.GPScal=0;
  }

  if (!mapfile) {
    if (LCD.bits<=8) {
      // default black & white index
      color.r=color.g=color.b=255;
      LCD.white=WinRGBToIndex (&color);
      color.r=color.g=color.b=0;
      LCD.black=WinRGBToIndex (&color);
      LCD.grid=WinRGBToIndex (&Prefs.bin.gridCol);
      LCD.ColorTable[LCD.white]=LCD.white;
      LCD.ColorTable[LCD.black]=LCD.black;
      LCD.ColorTable[LCD.grid]=LCD.grid;
    }

    RenewBitmap (8);
    MapInfo.curr_map.startX=MapInfo.curr_map.startY=0;
    
    return 1;
  }
  // header loading
  do {
    if ((err = VFSFileSeek (mapfile, vfsOriginBeginning, 0))!=errNone) 
      break;
    if ((err = VFSFileRead (mapfile, sizeof (MapInfo.MapHeader), &MapInfo.MapHeader, NULL))!=errNone)
      break;
  // conversion from low-endian to big-endian
    SB (&MapInfo.MapHeader.version, sizeof (MapInfo.MapHeader.version));
    SB (&MapInfo.MapHeader.size_x, sizeof (MapInfo.MapHeader.size_x));
    SB (&MapInfo.MapHeader.size_y, sizeof (MapInfo.MapHeader.size_y));
    SB (&MapInfo.MapHeader.Nx, sizeof (MapInfo.MapHeader.Nx));
    SB (&MapInfo.MapHeader.Ny, sizeof (MapInfo.MapHeader.Ny));
    SB (&MapInfo.MapHeader.Wx, sizeof (MapInfo.MapHeader.Wx));
    SB (&MapInfo.MapHeader.Wy, sizeof (MapInfo.MapHeader.Wy));
    SB (&MapInfo.MapHeader.min_x, sizeof (MapInfo.MapHeader.min_x));
    SB (&MapInfo.MapHeader.min_y, sizeof (MapInfo.MapHeader.min_y));
    SB (&MapInfo.MapHeader.max_x, sizeof (MapInfo.MapHeader.max_x));
    SB (&MapInfo.MapHeader.max_y, sizeof (MapInfo.MapHeader.max_y));
    SB (&MapInfo.MapHeader.table_offs, sizeof (MapInfo.MapHeader.table_offs));
    SB (&MapInfo.MapHeader.list_offs, sizeof (MapInfo.MapHeader.list_offs));
    SB (&MapInfo.MapHeader.add_offs, sizeof (MapInfo.MapHeader.add_offs));
    // check for signature
#ifndef force16bpp
    reloadPal=false;
#else
    reloadPal=true;
#endif
    LCD.translate=0;
    err=1;
    if (MapInfo.MapHeader.signature[0]!='B' || MapInfo.MapHeader.signature[1]!='M' || MapInfo.MapHeader.signature[2]!='v' || MapInfo.MapHeader.signature[3]!='w')
      break;
    // color table loading
    if (MapInfo.MapHeader.table_offs) {
      if ((err = VFSFileSeek (mapfile, vfsOriginBeginning, MapInfo.MapHeader.table_offs))!=errNone)
        break;
      if ((err = VFSFileRead (mapfile, 256*sizeof (colordef), CTable, NULL))!=errNone)
        break;
      // preparing grid color table
      // looking for grid color index
      cdi=1024;
      LCD.grid=50; // default grid color index if not specified or found
      for (i=0; i<256; i++) {
        rdi=CTable[i].rgb.R-Prefs.bin.gridCol.r; if (rdi<0) rdi=-rdi;
        gdi=CTable[i].rgb.G-Prefs.bin.gridCol.g; if (gdi<0) gdi=-gdi;
        bdi=CTable[i].rgb.B-Prefs.bin.gridCol.b; if (bdi<0) bdi=-bdi;
        if (rdi+gdi+bdi<cdi) {
          cdi=rdi+gdi+bdi;
          LCD.grid=i;
        }
      }
      cdi=CTable[LCD.grid].rgb.R+CTable[LCD.grid].rgb.G+CTable[LCD.grid].rgb.B;
      for (i=0; i<256; i++) {
        if (CTable[i].rgb.R+CTable[i].rgb.G+CTable[i].rgb.B>cdi)
          LCD.GridTable[i]=LCD.grid;
        else
          LCD.GridTable[i]=i;
      }
      // preparing color conversion table for various color modes
      if (LCD.bits<8) {
        for (i=0; i<256; i++) {
          // conversion table for devices with color depth < 8
          color.r=CTable[i].rgb.R;
          color.g=CTable[i].rgb.G;
          color.b=CTable[i].rgb.B;
          LCD.ColorTable[i]=webSafe4bpp[WinRGBToIndex (&color)];
        }
        LCD.translate=0x01;
      } else {
        // check palette against system palette
        WinPalette (winPaletteGet, 0, 256, newPal);
        for (i=0; i<256; i++) {
          // new palette for devices with color depth >= 8
          if (newPal[i].r!=CTable[i].rgb.R || newPal[i].g!=CTable[i].rgb.G || newPal[i].b!=CTable[i].rgb.B) {
            reloadPal=true;
            newPal[i].r=CTable[i].rgb.R;
            newPal[i].g=CTable[i].rgb.G;
            newPal[i].b=CTable[i].rgb.B;
          }
          newPal[i].index=i;
        }
        // if palette isn't equal to system palette
        if (reloadPal) {
#ifndef force16bpp
          switch ((Prefs.bin.flags&ColMask)>>ColBits) {
            case 0x01: // load user palette
              SetLCDmode (8);
              WinPalette (winPaletteSet, 0, 256, newPal);
              LCD.systemPalette=false;
              break;
            case 0x02: // use 16bpp
#endif
              SetLCDmode (16);
              // creating direct-color conversion table
              for (i=0; i<256; i++) {
                LCD.RGB16[i]=((((UInt16)CTable[i].rgb.R)<<8) & 0xF800) | ((((UInt16)CTable[i].rgb.G)<<3) & 0x07E0) | ((((UInt16)CTable[i].rgb.B)>>3) & 0x001F);
              }
              LCD.translate=0x10;
#ifndef force16bpp
              break;
            case 0x00: // use system palette
            default:
              SetLCDmode (8);
              // make conversion table from user palette to system palette
              for (i=0; i<256; i++) {
                color.r=CTable[i].rgb.R;
                color.g=CTable[i].rgb.G;
                color.b=CTable[i].rgb.B;
                LCD.ColorTable[i]=WinRGBToIndex (&color);
              }
              LCD.translate=0x01;
              break;
          }
#endif
        } else {
          if (LCD.bits>8)
            SetLCDmode (8);
        }
      }
    } else {
      //color palette isn't in file - suppose standard palmOS palette
      // so maybe set default palette...?
      if (LCD.bits>=8) {
        WinPalette (winPaletteSetToDefault, 0, 0, NULL);
        LCD.systemPalette=true;
      }
      // default grid conversion table
    }
    // if no table presented, calc namelen
    if (!MapInfo.MapHeader.list_offs) {
      // preparing pointer to extension (end of filename)
      i=0;
      // looking for '.' - multiple dots not supported!
      while (MapInfo.curr_filename[i] && MapInfo.curr_filename[i]!='.') i++;
      while (i && MapInfo.curr_filename[i-1]>='0' && MapInfo.curr_filename[i-1]<='9') i--;
      MapInfo.namelen=i;
    }
    // load additional information if header version is 0x02 or higher
    Prefs.bin.flags&=~GridInside;
    if ((MapInfo.MapHeader.version & 0xFF00)>0x0100) {
      if ((err=VFSFileSeek (mapfile, vfsOriginBeginning, MapInfo.MapHeader.add_offs)))
        break;
      while (!VFSFileEOF (mapfile)) {
        if ((err=VFSFileRead (mapfile, sizeof (add_hdr), &add_hdr, NULL)))
          break;
        err=1;
        if (!add_hdr.id && !add_hdr.size)
          break;
        SB (&add_hdr.id, sizeof (add_hdr.id));
        SB (&add_hdr.size, sizeof (add_hdr.size));
        err=errNone;
        load_size=add_hdr.size;
        switch (add_hdr.id) {
        case gridX_id:
          if (load_size>sizeof (MapInfo.gridX)) load_size=sizeof (MapInfo.gridX);
          if ((err=VFSFileRead (mapfile, load_size, &MapInfo.gridX, NULL)))
            break;
          SB (&MapInfo.gridX.pixels, sizeof (MapInfo.gridX.pixels));
          SB (&MapInfo.gridX.measure, sizeof (MapInfo.gridX.measure));
          break;
        case gridY_id:
          if (load_size>sizeof (MapInfo.gridY)) load_size=sizeof (MapInfo.gridY);
          if ((err=VFSFileRead (mapfile, load_size, &MapInfo.gridY, NULL)))
            break;
          SB (&MapInfo.gridY.pixels, sizeof (MapInfo.gridY.pixels));
          SB (&MapInfo.gridY.measure, sizeof (MapInfo.gridY.measure));
          break;
        case gridIN_id:
          Prefs.bin.flags|=GridInside;
          break;
        case SupTile:
          if (load_size>sizeof (MapInfo.SuperTile)) load_size=sizeof (MapInfo.SuperTile);
          if ((err=VFSFileRead (mapfile, load_size, &MapInfo.SuperTile, NULL)))
            break;
          SB (&MapInfo.SuperTile.Nx_offs, sizeof (MapInfo.SuperTile.Nx_offs));
          SB (&MapInfo.SuperTile.Ny_offs, sizeof (MapInfo.SuperTile.Ny_offs));
          SB (&MapInfo.SuperTile.Nx, sizeof (MapInfo.SuperTile.Nx));
          SB (&MapInfo.SuperTile.Ny, sizeof (MapInfo.SuperTile.Ny));
          break;
        case GPS_info:
          if (load_size>sizeof(GPSinfoType)) load_size=sizeof (GPSinfoType);
          if ((err=VFSFileRead (mapfile, load_size, &GPSinfo, NULL)))
            break;
          SB (&GPSinfo.x, sizeof (GPSinfo.x));
          SB (&GPSinfo.y, sizeof (GPSinfo.y));
          SB (&GPSinfo.lat, sizeof (GPSinfo.lat));
          SB (&GPSinfo.lon, sizeof (GPSinfo.lon));
          MapInfo.GPScount++;
          if (!MapInfo.GPScal) {
            hndl=MemHandleNew (MapInfo.GPScount * sizeof (GPSinfo));
            if (hndl) MapInfo.GPScal = MemHandleLock (hndl);
            if (MapInfo.GPScount>1) DEBUG ("Toto je chyba!");
          } else {
            hndl = MemPtrRecoverHandle (MapInfo.GPScal);
            MemHandleUnlock (hndl);
            if (MemHandleResize (hndl, MapInfo.GPScount*sizeof (GPSinfo))) {
              MemHandleFree (hndl);
              MapInfo.GPScal=0;
            } else {
              MapInfo.GPScal = MemHandleLock (hndl);
            }
          }
          if (MapInfo.GPScal)
            MemMove (&MapInfo.GPScal[MapInfo.GPScount-1], &GPSinfo, sizeof (GPSinfo));
          break;
        default:
          err=VFSFileSeek (mapfile, vfsOriginCurrent, add_hdr.size);
          break;
        }
        if (err) break;
        if (add_hdr.size>load_size)
          VFSFileSeek (mapfile, vfsOriginCurrent, add_hdr.size-load_size);
      }
      // init uninitialized info
      if ((MapInfo.gridX.pixels && !MapInfo.gridY.pixels) || (MapInfo.gridX.measure && !MapInfo.gridY.measure)) {
        MapInfo.gridY.pixels=MapInfo.gridX.pixels;
        MapInfo.gridY.measure=MapInfo.gridX.measure;
        StrCopy (MapInfo.gridY.unit, MapInfo.gridX.unit);
      }
      if ((MapInfo.gridY.pixels && !MapInfo.gridX.pixels) || (MapInfo.gridY.measure && !MapInfo.gridX.measure)) {
        MapInfo.gridX.pixels=MapInfo.gridY.pixels;
        MapInfo.gridX.measure=MapInfo.gridY.measure;
        StrCopy (MapInfo.gridX.unit, MapInfo.gridY.unit);
      }
    }
    err=errNone;
  } while (0);
  // close map header file
  VFSFileClose (mapfile);
  if (err!=errNone) {
    FrmAlert (mapFileError);
    return 2;
  }
  MapInfo.valid=true;
  // bitmap tile space
  if (RenewBitmap (LCD.translate==0x10?16:8)) {
    FrmAlert (memoryError);
    return 3;
  }
  // 
  CalcRotatedVars ();
  // cartoon mode override
  if (MapInfo.MapHeader.version&CartoonFile && func==posSetRel && MapInfo.rel_pos_x==0.5 && MapInfo.rel_pos_y==0.5)
    MapInfo.rel_pos_x=MapInfo.rel_pos_y=0;
  // do specific position recalculation
  switch (func) {
    case posCheck:
      break;
    case posSetRel:
      MapInfo.curr_map.startX=(MapInfo.rel_pos_x*(MapInfo.MapHeader.max_x-MapInfo.MapHeader.min_x)+MapInfo.MapHeader.Wx/2)/MapInfo.MapHeader.Wx-MapInfo.Xtiles/2;
      MapInfo.curr_map.startY=(MapInfo.rel_pos_y*(MapInfo.MapHeader.max_y-MapInfo.MapHeader.min_y)+MapInfo.MapHeader.Wy/2)/MapInfo.MapHeader.Wy-MapInfo.Ytiles/2;
      break;
    default: // center position - shouldn't be used...
      MapInfo.curr_map.startX=MapInfo.MapHeader.Nx/2-MapInfo.Xtiles/2;
      MapInfo.curr_map.startY=MapInfo.MapHeader.Ny/2-MapInfo.Ytiles/2;
      break;
  }
  // check min/max coords
  CheckStartXY ();

  if ((MapInfo.MapHeader.version&CompressedMask)==CompressedZLIB && DrawInfo.ZLibRefNum==sysInvalidRefNum)
    FrmAlert (zlibNotFound);
    
  if ((MapInfo.MapHeader.version&CompressedMask)>CompressedMax)
    FrmAlert (unsupportedCompression);

  if (LCD.bits<=8) {
    // preparing new black & white index
    color.r=color.g=color.b=255;
    LCD.white=WinRGBToIndex (&color);
    color.r=color.g=color.b=0;
    LCD.black=WinRGBToIndex (&color);
  }

  MapInfo.valid=true;
  return 0;
}
// ------------------------------------
// rotates bitmap for current LCD rotation
// ------------------------------------
void RotateBitmap (UInt8 *bitmap) {
UInt8 buf;
UInt16 i1, i2, i3, i4;
Int16 x, y;

  if (bitmap==NULL || !LCD.rotate) return;
  if (MapInfo.MapHeader.Wx!=MapInfo.MapHeader.Wy) return;
  switch (LCD.rotate) {
    case 1: // 90
      for (y=0; y<MapInfo.MapHeader.Wy/2; y++) {
        i1=MapInfo.MapHeader.Wx*y;
        i2=MapInfo.MapHeader.Wx-y-1;
        i3=MapInfo.MapHeader.Wx*(MapInfo.MapHeader.Wy-y)-1;
        i4=MapInfo.MapHeader.Wx*(MapInfo.MapHeader.Wy-1)+y;
        for (x=0; x<MapInfo.MapHeader.Wx/2; x++) {
          buf=bitmap[i1];
          bitmap[i1]=bitmap[i4];
          bitmap[i4]=bitmap[i3];
          bitmap[i3]=bitmap[i2];
          bitmap[i2]=buf;
          i1++;
          i2+=MapInfo.MapHeader.Wx;
          i3--;
          i4-=MapInfo.MapHeader.Wx;
        }
      }
      break;
    case 2: //180
      i1=0;
      i2=MapInfo.MapHeader.Wx*MapInfo.MapHeader.Wy-1;
      for (y=0; y<MapInfo.MapHeader.Wy/2; y++) {
        for (x=0; x<MapInfo.MapHeader.Wx; x++) {
          buf=bitmap[i1];
          bitmap[i1]=bitmap[i2];
          bitmap[i2]=buf;
          i1++;
          i2--;
        }
      }
      break;
    case 3: // 270
      for (y=0; y<MapInfo.MapHeader.Wy/2; y++) {
        i1=MapInfo.MapHeader.Wx*y;
        i2=MapInfo.MapHeader.Wx-y-1;
        i3=MapInfo.MapHeader.Wx*(MapInfo.MapHeader.Wy-y)-1;
        i4=MapInfo.MapHeader.Wx*(MapInfo.MapHeader.Wy-1)+y;
        for (x=0; x<MapInfo.MapHeader.Wx/2; x++) {
          buf=bitmap[i1];
          bitmap[i1]=bitmap[i2];
          bitmap[i2]=bitmap[i3];
          bitmap[i3]=bitmap[i4];
          bitmap[i4]=buf;
          i1++;
          i2+=MapInfo.MapHeader.Wx;
          i3--;
          i4-=MapInfo.MapHeader.Wx;
        }
      }
      break;
  }
}
// ------------------------------------
// rotates drawing coordinates
// ------------------------------------
void RotateDrawCoords (Coord *x, Coord *y) {
Coord buf;

  if (MapInfo.MapHeader.Wx!=MapInfo.MapHeader.Wy) return;
  switch (LCD.rotate) {
    case 1:
      buf=*x;
      *x=LCD.form.native.width-*y-MapInfo.MapHeader.Wy;
      *y=buf;
      break;      
    case 2:
      *x=LCD.form.native.width-*x-MapInfo.MapHeader.Wx;
      *y=LCD.form.native.height-*y-MapInfo.MapHeader.Wy;
      break;            
    case 3:
      buf=*x;
      *x=*y;
      *y=LCD.form.native.height-buf-MapInfo.MapHeader.Wx;
      break;      
  }
}
// ------------------------------------
// draw one bitmap tile (nx, ny) to [sx, sy] coordinates
// ------------------------------------
static int DrawBitmap (Coord sx, Coord sy, UInt16 nx, UInt16 ny) SECT_FUNC;
static int DrawBitmap (Coord sx, Coord sy, UInt16 nx, UInt16 ny) {
Coord           x;
UInt16          idx, istop;
UInt32          data_offs;
Err             err;
UInt16		size;
UInt32          gmin, gmax, gi;
FileRef         mapfile;
Char            filename[256];
MapHeaderType   loc_header;
UInt32          tile_ptr, tile_nr;

  if (DrawInfo.bitmap==NULL || DrawInfo.bitdata==NULL) return 0;

  mapfile=0;
  // opening file
  if (!*MapInfo.curr_map.name) return 0;
  if (!*MapInfo.curr_filename) return 0;
  if (!MapInfo.valid) return 0;

  // if multi-file map is opened, create unique name
  if (!MapInfo.MapHeader.list_offs) {
    StrCopy (filename, Prefs.str[homedir]);
    StrPrintF (&filename[StrLen (filename)], MapInfo.SuperTile.name_mask, tile_nr=(ny/MapInfo.SuperTile.Ny)*(MapInfo.MapHeader.Nx/MapInfo.SuperTile.Nx+MapInfo.SuperTile.Ny_offs)+nx/MapInfo.SuperTile.Nx+MapInfo.SuperTile.Nx_offs);
    StrCat (filename, &MapInfo.curr_filename[MapInfo.namelen]);
  } else {
    MemMove (&loc_header, &MapInfo.MapHeader, sizeof (MapHeaderType));
    StrCopy (filename, MapInfo.curr_filename);
    tile_nr=0;
  }

  err = VFSFileOpen (MapInfo.curr_map.volRefNum, filename, vfsModeRead, &mapfile);
  if (err!=errNone) {
    mapfile=0;
  }
  
  do {
    data_offs=0;
    err=appErrorClass+1;
    if (!mapfile) break;
    err=errNone;
    if (nx>=MapInfo.MapHeader.Nx || ny>=MapInfo.MapHeader.Ny) break;
    if (!MapInfo.MapHeader.list_offs) {
      // load actual map header
      err=VFSFileRead (mapfile, sizeof (MapHeaderType), &loc_header, NULL);
      if (err!=errNone) break;
      SB (&loc_header.version, sizeof (loc_header.version));
      SB (&loc_header.list_offs, sizeof (loc_header.list_offs));
      tile_ptr=loc_header.list_offs+(MapInfo.SuperTile.Nx*(ny%MapInfo.SuperTile.Ny)+(nx%MapInfo.SuperTile.Nx))*sizeof (UInt32);
      // copy actual compression to main header space
      MapInfo.MapHeader.version&=~CompressedFile;
      MapInfo.MapHeader.version|=loc_header.version&CompressedFile;
    } else
      tile_ptr=MapInfo.MapHeader.list_offs+(MapInfo.MapHeader.Nx*ny+nx)*sizeof (UInt32);
    err = VFSFileSeek (mapfile, vfsOriginBeginning, tile_ptr);
    if (err!=errNone) break;
    err = VFSFileRead (mapfile, sizeof (UInt32), &data_offs, NULL);
    if (err!=errNone) break;
    SB (&data_offs, sizeof (data_offs));
    if (data_offs) {
      // bitmap data should exist
      err = VFSFileSeek (mapfile, vfsOriginBeginning, data_offs);
      if (err!=errNone) break;
      if (!(loc_header.version&CompressedFile)) {
        err = VFSFileRead (mapfile, MapInfo.MapHeader.Wx*MapInfo.MapHeader.Wy, DrawInfo.bitdata, NULL);
        MapInfo.ratio1+=MapInfo.MapHeader.Wx*MapInfo.MapHeader.Wy;
        MapInfo.ratio2=MapInfo.ratio1;
      } else {
        err=appErrorClass+2;
        if (DrawInfo.zip_data==NULL) break;
        err = VFSFileRead (mapfile, 2, &size, NULL);
        if (err!=errNone) break;
        SB (&size, sizeof (size));
        err = VFSFileRead (mapfile, size, DrawInfo.zip_data, NULL);
        data_offs=MapInfo.MapHeader.Wx*MapInfo.MapHeader.Wy;
        switch (loc_header.version&CompressedMask) {
        case CompressedZLIB: // ZLib compression
          err=appErrorClass+3;
          if (DrawInfo.ZLibRefNum==sysInvalidRefNum) break;
          err=ZLibuncompress (DrawInfo.ZLibRefNum, DrawInfo.bitdata, &data_offs, DrawInfo.zip_data, size);
#if Z_OK!=errNone
          if (err==Z_OK) err=errNone;
#endif
	  if (err==errNone) {
	    MapInfo.ratio1+=size;
	    MapInfo.ratio2+=MapInfo.MapHeader.Wx*MapInfo.MapHeader.Wy;
	  }
          break;
        case CompressedLZO: // LZO compression
          err=lzo1x_decompress (DrawInfo.zip_data, size, DrawInfo.bitdata, &data_offs, NULL);
#if LZO_E_OK!=errNone
	  if (err==LZO_E_OK) err=errNone;
#endif
	  if (err==errNone) {
	    MapInfo.ratio1+=size;
	    MapInfo.ratio2+=MapInfo.MapHeader.Wx*MapInfo.MapHeader.Wy;
	  }
          break;
        default:
          break;
        }
      }
      //if (err!=errNone) break;
    }
  } while (0);
  // if bitmap is omited, draw white bitmap
  // if something went wrong, draw B&W bitmap
  if (err!=errNone || !data_offs) {
    // make white tile
    x=MapInfo.MapHeader.Wx*MapInfo.MapHeader.Wy;
    for (idx=0; idx<x; idx++) {
      DrawInfo.bitdata[idx]=LCD.white;
    }
    if (err!=errNone) {
      // make black lines in tile
      for (x=0; x<MapInfo.MapHeader.Wx && x<MapInfo.MapHeader.Wy; x++) {
        DrawInfo.bitdata[x*(MapInfo.MapHeader.Wx+1)]=LCD.black;
        DrawInfo.bitdata[x*(MapInfo.MapHeader.Wx-1)+MapInfo.MapHeader.Wx-1]=LCD.black;
      }
      // if this is super-tile map, print map number
      //if (!MapInfo.MapHeader.list_offs) {
      //}
    }
  }

  // if grid should be in the map
  if (MapInfo.gridX.pixels && Prefs.bin.flags&Grid_mask && !(Prefs.bin.flags&GridInside)) {
    gmin=nx*(UInt32)MapInfo.MapHeader.Wx;
    gi=(gmin/MapInfo.gridX.pixels)*MapInfo.gridX.pixels;
    while (gi<gmin) gi+=MapInfo.gridX.pixels;
    gmax=gmin+MapInfo.MapHeader.Wx-1;
    while (gi<=gmax) {
      idx=gi%MapInfo.MapHeader.Wx;
      istop=MapInfo.MapHeader.Wx*MapInfo.MapHeader.Wy;
      while (idx<istop) {
        DrawInfo.bitdata[idx]=LCD.GridTable[DrawInfo.bitdata[idx]];
        idx+=MapInfo.MapHeader.Wx;
      }
      gi+=MapInfo.gridX.pixels;
    }
  }
  if (MapInfo.gridY.pixels && Prefs.bin.flags&Grid_mask && !(Prefs.bin.flags&GridInside)) {
    gmin=ny*(UInt32)MapInfo.MapHeader.Wy;
    gi=(gmin/MapInfo.gridY.pixels)*MapInfo.gridY.pixels;
    while (gi<gmin) gi+=MapInfo.gridY.pixels;
    gmax=gmin+MapInfo.MapHeader.Wy-1;
    while (gi<=gmax) {
      idx=(gi%MapInfo.MapHeader.Wy)*MapInfo.MapHeader.Wx;
      istop=idx+MapInfo.MapHeader.Wx;
      while (idx<istop) {
        DrawInfo.bitdata[idx]=LCD.GridTable[DrawInfo.bitdata[idx]];
        idx++;
      }
      gi+=MapInfo.gridX.pixels;
    }
  }
  // if rotation is required
  if (LCD.rotate) {
    RotateBitmap (DrawInfo.bitdata);
    RotateDrawCoords (&sx, &sy);
  }
  // if selected conversion to other 8-bit space (system?)
  if (LCD.translate==0x01) {
    x=MapInfo.MapHeader.Wx*MapInfo.MapHeader.Wy;
    for (idx=0; idx<x; idx++)
      DrawInfo.bitdata[idx]=LCD.ColorTable[DrawInfo.bitdata[idx]];
  }
  // if selected convert 8bit to 16bit direct color
  if (LCD.translate==0x10) {
    for (idx=MapInfo.MapHeader.Wx*MapInfo.MapHeader.Wy; idx; ) {
      idx--;
      ((UInt16*)DrawInfo.bitdata)[idx]=LCD.RGB16[DrawInfo.bitdata[idx]];
    }
  }
  // drawing bitmap
  if (LCD.sonyHiResRefNum!=sysInvalidRefNum) {
    HRWinDrawBitmap (LCD.sonyHiResRefNum, DrawInfo.bitmap, sx, sy);
  } else {
    if (LCD.density!=kDensityLow)
      WinSetCoordinateSystem (kCoordinatesNative);
    WinDrawBitmap (DrawInfo.bitmap, sx, sy);
    if (LCD.density!=kDensityLow)
      WinSetCoordinateSystem (kCoordinatesStandard);
  }
  if (err!=errNone && !MapInfo.MapHeader.list_offs) {
    Char num[12];
    StrPrintF (num, "%ld", tile_nr);
    if (LCD.sonyHiResRefNum!=sysInvalidRefNum) {
      HRWinDrawChars (LCD.sonyHiResRefNum, num, StrLen (num), sx, sy);
    } else {
      if (LCD.density!=kDensityLow)
        WinSetCoordinateSystem (kCoordinatesNative);
      WinDrawChars (num, StrLen (num), sx, sy);
      if (LCD.density!=kDensityLow)
        WinSetCoordinateSystem (kCoordinatesStandard);
    }
  }
  
  if (mapfile)
    VFSFileClose (mapfile);

  return 0;
}
// ------------------------------------
// draw more tiles for entered position
// [x,y] - LCD coordinates
// [row,col] - file 'coordinates'
// [nx,ny] - count of tiles
// ------------------------------------
Int16 ShowBitmaps (Int16 x, Int16 y, UInt16 col, UInt16 row, UInt16 nx, UInt16 ny) {
Int16	xc, yc;
UInt16	r_idx, c_idx;
UInt32	ticks;

  MenuEraseStatus (NULL);
  ticks=0;
  if (!MapInfo.speed_index) ticks=TimGetTicks ();
  yc=y-MapInfo.yOff;
  for (r_idx=row; r_idx<row+ny; r_idx++) {
    xc=x-MapInfo.xOff;
    for (c_idx=col; c_idx<col+nx; c_idx++) {
      DrawBitmap (xc, yc, c_idx, r_idx);
      xc+=MapInfo.MapHeader.Wx;
    }
    yc+=MapInfo.MapHeader.Wy;
  }
  if (!MapInfo.speed_index) MapInfo.speed_index=TimGetTicks ()-ticks;
  return 0;
}
// ------------------------------------
// move LCD view to requested direction and redraw required region(s)
// ------------------------------------
Int16 MoveMap (Int16 dir) {
RectangleType   box;
Int8            slines;
Int16           flags;
Int32 xScroll=MapInfo.MapHeader.Wx, yScroll=MapInfo.MapHeader.Wy;

  flags=0;
  // test for coordinates (w/ rotation transform)
  RotateDirRight (&dir);
  if (dir&dirLeft) {
    if(MapInfo.xOff) {
      xScroll=MapInfo.xOff; MapInfo.xOff=0;
    } else if (MapInfo.curr_map.startX)
      MapInfo.curr_map.startX--;
    else {
      if (Prefs.bin.flags&CartoonMode || MapInfo.MapHeader.version&CartoonFile) {
        slines=MapInfo.Ytiles/2;
        // move up for next cartoon line (half display)
        while (slines && MapInfo.curr_map.startY) {
          MapInfo.curr_map.startY--;
          slines--;
          flags|=dirCartLine;
        }
        if (flags&dirCartLine) {
          MapInfo.curr_map.startX=MapInfo.MapHeader.Nx-MapInfo.Xtiles;
          if (MapInfo.curr_map.startX<0) MapInfo.curr_map.startX=0;
        } else {
          // prev cartoon page loading
          if (!TestFile (-1)) {
            MapInfo.rel_pos_x=MapInfo.rel_pos_y=1;
            LoadMapFile (posSetRel);
            flags|=dirCartPage;
          }
        }
      }
      dir&=~dirLeft;
    }
  } else
  if (dir&dirRight) {
    if(MapInfo.xOff==0 && MapInfo.xRest)
        xScroll=MapInfo.xOff=MapInfo.xRest;
    else if (MapInfo.curr_map.startX+MapInfo.Xtiles<MapInfo.MapHeader.Nx) {
      MapInfo.curr_map.startX++;
    } else {
      if (Prefs.bin.flags&CartoonMode || MapInfo.MapHeader.version&CartoonFile) {
        slines=MapInfo.Ytiles/2;
        // move down for next cartoon line (half display)
        while (slines && MapInfo.curr_map.startY+MapInfo.Ytiles<MapInfo.MapHeader.Ny) {
          MapInfo.curr_map.startY++;
          slines--;
          flags|=dirCartLine;
        }
        if (flags&dirCartLine) {
          MapInfo.curr_map.startX=0;
        } else {
          // next cartoon page loading
          if (!TestFile (1)) {
            MapInfo.rel_pos_x=MapInfo.rel_pos_y=0;
            LoadMapFile (posSetRel);
            flags|=dirCartPage;
          }
        }
      }
      dir&=~dirRight;
    }
  }
  if (dir&dirUp) {
    if(MapInfo.yOff) {
      yScroll=MapInfo.yOff; MapInfo.yOff=0;
    } else if (MapInfo.curr_map.startY)
      MapInfo.curr_map.startY--;
    else {
      if (Prefs.bin.flags&CartoonMode || MapInfo.MapHeader.version&CartoonFile) {
        // go directly to previous page
        if (!TestFile (-1)) {
          MapInfo.rel_pos_x=(MapInfo.curr_map.startX+MapInfo.Xtiles/2)*MapInfo.MapHeader.Wx/(double)(MapInfo.MapHeader.max_x-MapInfo.MapHeader.min_x);
          MapInfo.rel_pos_y=1;
          LoadMapFile (posSetRel);
          flags|=dirCartPage;
        }
      }
      dir&=~dirUp;
    }
  } else
  if (dir&dirDown) {
    if(MapInfo.yOff==0 && MapInfo.yRest)
      yScroll=MapInfo.yOff=MapInfo.yRest;
    else if (MapInfo.curr_map.startY+MapInfo.Ytiles<MapInfo.MapHeader.Ny)
      MapInfo.curr_map.startY++;
    else {
      if (Prefs.bin.flags&CartoonMode || MapInfo.MapHeader.version&CartoonFile) {
        // go directly to next page
        if (!TestFile (1)) {
          MapInfo.rel_pos_x=(MapInfo.curr_map.startX+MapInfo.Xtiles/2)*MapInfo.MapHeader.Wx/(double)(MapInfo.MapHeader.max_x-MapInfo.MapHeader.min_x);
          MapInfo.rel_pos_y=0;
          LoadMapFile (posSetRel);
          flags|=dirCartPage;
        }
      }
      dir&=~dirDown;
    }
  }
  if (!dir && !flags) return 1;
  if (selectPoint!=pointNone) DistanceWindow (false);
  RotateDirLeft (&dir);
  if(LCD.rotate==1 || LCD.rotate==3) {
    Int32 a=xScroll;
    xScroll=yScroll;
    yScroll=a;
  }
  // physical content movement (w/o rotation transform)
  MenuEraseStatus (NULL);
  // horizontal scrolling
  if (dir & (dirLeft|dirRight)) {
    box.topLeft.x=0; box.topLeft.y=0;
    box.extent.x=LCD.form.native.width; box.extent.y=LCD.form.native.height;
    if (LCD.sonyHiResRefNum!=sysInvalidRefNum) {
      HRWinScrollRectangle (LCD.sonyHiResRefNum, &box, dir&dirLeft?winRight:winLeft, xScroll, &box);
      HRWinEraseRectangle (LCD.sonyHiResRefNum, &box, 0);
    } else {
      if (LCD.density!=kDensityLow)
        WinSetCoordinateSystem (kCoordinatesNative);
      WinScrollRectangle (&box, dir&dirLeft?winRight:winLeft, xScroll, &box);
      WinEraseRectangle (&box, 0);
      if (LCD.density!=kDensityLow)
        WinSetCoordinateSystem (kCoordinatesStandard);
    }
  }
  // vertical scolling
  if (dir & (dirUp|dirDown)) {
    box.topLeft.x=0; box.topLeft.y=0;
    box.extent.x=LCD.form.native.width; box.extent.y=LCD.form.native.height;
    if (LCD.sonyHiResRefNum!=sysInvalidRefNum) {
      HRWinScrollRectangle (LCD.sonyHiResRefNum, &box, dir&dirUp?winDown:winUp, yScroll, &box);
      HRWinEraseRectangle (LCD.sonyHiResRefNum, &box, 0);
    } else {
      if (LCD.density!=kDensityLow)
        WinSetCoordinateSystem (kCoordinatesNative);
      WinScrollRectangle (&box, dir&dirUp?winDown:winUp, yScroll, &box);
      WinEraseRectangle (&box, 0);
      if (LCD.density!=kDensityLow)
        WinSetCoordinateSystem (kCoordinatesStandard);
    }
  }
  RotateDirRight (&dir);
  // map drawing - w/ rotation transform
  if (dir & (dirLeft|dirRight))
//    ShowBitmaps (dir&dirLeft?0:(MapInfo.Xtiles-(MapInfo.incompleteX?2:1))*MapInfo.MapHeader.Wx, 0, MapInfo.curr_map.startX+(dir&dirLeft?0:MapInfo.Xtiles-(MapInfo.incompleteX?2:1)), MapInfo.curr_map.startY, (dir&dirRight && MapInfo.incompleteX)?2:1, MapInfo.Ytiles);
    ShowBitmaps (dir&dirLeft?0:(MapInfo.Xtiles-1)*MapInfo.MapHeader.Wx, 0, MapInfo.curr_map.startX+(dir&dirLeft?0:MapInfo.Xtiles-1), MapInfo.curr_map.startY, 1, MapInfo.Ytiles);
  if (dir & (dirUp|dirDown))
//    ShowBitmaps (0, dir&dirUp?0:(MapInfo.Ytiles-(MapInfo.incompleteY?2:1))*MapInfo.MapHeader.Wy, MapInfo.curr_map.startX, MapInfo.curr_map.startY+(dir&dirUp?0:(MapInfo.Ytiles-(MapInfo.incompleteY?2:1))), MapInfo.Xtiles, (dir&dirDown && MapInfo.incompleteY)?2:1);
    ShowBitmaps (0, dir&dirUp?0:(MapInfo.Ytiles-1)*MapInfo.MapHeader.Wy, MapInfo.curr_map.startX, MapInfo.curr_map.startY+(dir&dirUp?0:(MapInfo.Ytiles-1)), MapInfo.Xtiles, 1);
// cartoon support
  if (flags & (dirCartLine | dirCartPage)) 
    ShowBitmaps (0, 0, MapInfo.curr_map.startX, MapInfo.curr_map.startY, MapInfo.Xtiles, MapInfo.Ytiles);
  if (selectPoint!=pointNone) DistanceWindow (true);

  return 0;
}
// ------------------------------------
// buffered string reading from VFS file
// ------------------------------------
static Char buf[256];
static UInt32 buflen, bufpos;
static Char *getstr (FileRef file, Char *str, UInt16 maxlen) SECT_FUNC;
static Char *getstr (FileRef file, Char *str, UInt16 maxlen) {
UInt16 strpos;

  if (maxlen<2) return NULL;
  strpos=0;
  maxlen--;
  while (strpos<maxlen) {
    if (bufpos==buflen) {
      VFSFileRead (file, 256, buf, &buflen);
      bufpos=0;
      if (!buflen) break;
    }
    str[strpos++]=buf[bufpos++];
    if (str[strpos-1]=='\n') break;
  }
  str[strpos]=0;
  if (!strpos) return NULL;
  return str;
}
// ------------------------------------
// skip spaces in string
// ------------------------------------
UInt16 SkipSpaces (Char *str) {
UInt16 idx=0;
  while (str[idx]>0 && str[idx]<=' ') idx++;
  return idx;  
}
// ------------------------------------
// read/get float value from string
// ------------------------------------
UInt16 GetFloat (Char *str, double *val) {
double retval, mask;
UInt16 idx, sign, exp;
  retval=0;
  sign=idx=exp=0;
  if (str[idx]=='+') idx++;
  else
  if (str[idx]=='-') {sign=1; idx++;}
  if (str[idx]<'0' || str[idx]>'9') return 0;
  while (str[idx]>='0' && str[idx]<='9') {
    retval*=10;
    retval+=str[idx]-'0';
    idx++;
  }
  if (str[idx]=='.' || str[idx]==',') {
    idx++;
    mask=0.1;
    while (str[idx]>='0' && str[idx]<='9') {
      retval+=mask*(str[idx]-'0');
      mask/=10;
      idx++;
    }
  }
  if (sign) retval=-retval;
  if (str[idx]=='e' || str[idx]=='E') {
    idx++;
    sign=0;
    if (str[idx]=='+') idx++;
    else
    if (str[idx]=='-') {sign=1; idx++;}
    while (str[idx]>='0' && str[idx]<='9') {
      exp*=10;
      exp+=str[idx]-'0';
      idx++;
    }
    if (sign) {
      while (exp) {
        retval/=10;
        exp--;
      }
    } else {
      while (exp) {
        retval*=10;
        exp--;
      }
    }
  }
  *val=retval;
  return idx;
}
// ------------------------------------
// look for requested ZOOM map file
// ------------------------------------
Int16 TestFile (int step) {
Char newname[256], *s;
FileRef testfile;
Err err;
UInt16 idx, actpos, zoompos;
Int16 zoomdif, maxdif;
Char line[256];
UInt16 flags;
double new_rel_x, new_rel_y;
double A, B, C, D, E, F;

  if (!*MapInfo.curr_map.name) return 1;
  while (!VFSInfo.DirectoryOK) GetDirEntry (-1);
  // look for the name in VFSInfo.maplist
  for (idx=0; idx<VFSInfo.mapcount; idx++)
    if (!StrCaselessCompare (VFSInfo.maplist[idx]->name, MapInfo.curr_map.name)) break;
  if (idx>=VFSInfo.mapcount) return 2;
  // looking for nearer zoom number
  actpos=zoompos=idx;
  maxdif=0x7FFF;
  for (idx=0; idx<VFSInfo.mapcount; idx++) {
    if (VFSInfo.maplist[idx]->index!=VFSInfo.maplist[actpos]->index) continue;
    if (idx==actpos) continue;
    if (step<0) { // ZOOM out
      if (step<-1) { // map TOP (smallest zoom number)
        if (VFSInfo.maplist[idx]->zoom<VFSInfo.maplist[zoompos]->zoom)
          zoompos=idx;
      } else { // previous zoom number
        zoomdif=VFSInfo.maplist[actpos]->zoom-VFSInfo.maplist[idx]->zoom;
        if (VFSInfo.maplist[idx]->zoom<VFSInfo.maplist[actpos]->zoom && zoomdif>0 && zoomdif<=maxdif) {
          maxdif=zoomdif;
          zoompos=idx;
        }
      }
    } else { // ZOOM in
      zoomdif=VFSInfo.maplist[idx]->zoom-VFSInfo.maplist[actpos]->zoom;
      if (VFSInfo.maplist[idx]->zoom>VFSInfo.maplist[actpos]->zoom && zoomdif>0 && zoomdif<=maxdif) {
        maxdif=zoomdif;
        zoompos=idx;
      }
    }
  }
  if (zoompos!=actpos) {
    StrCopy (MapInfo.curr_map.name, VFSInfo.maplist[zoompos]->name);
    MapInfo.curr_map.volRefNum=VFSInfo.maplist[zoompos]->volRefNum;
    return 0;
  }
  if (step<-1) return 3;
  // parsing MapView.BML file
  StrCopy (newname, Prefs.str[homedir]);
  StrCat (newname, "MapView.bml");
  err = VFSFileOpen (VFSInfo.maplist[VFSInfo.linkindex]->volRefNum, newname, vfsModeRead, &testfile);
  if (err!=errNone) return 4;
  // initializing file access
  bufpos=buflen=0;
  flags=0;
  *newname=0;
  // looking for [<mapname>]
  while (!VFSFileEOF (testfile) || bufpos!=buflen) {
    s=getstr (testfile, line, 256);
    if (s==NULL) break;
    if (*s=='[') {
      if (StrNCaselessCompare (VFSInfo.maplist[actpos]->name, &line[1], VFSInfo.maplist[actpos]->namelen)) {
        // if there can't be the name repeated, exit the loop
        if (flags) break;
        //flags=0;
        continue;
      }
      // name found
      // hope that there aren't short names equal to beginning of longer ones...
      flags|=0x01;
      continue;
    }
    if (!flags) continue;
    if ((step<1 && *s!='<') || (step>-1 && *s!='>')) continue;
    // parse this line
    idx=1;
    A=D=1;
    B=C=E=F=0;
    *newname=0;
    do {
      idx+=SkipSpaces (&line[idx]);
      if (!(maxdif=GetFloat (&line[idx], &A))) break;
      idx+=maxdif;
      idx+=SkipSpaces (&line[idx]);
      if (!(maxdif=GetFloat (&line[idx], &B))) break;
      idx+=maxdif;
      idx+=SkipSpaces (&line[idx]);
      if (!(maxdif=GetFloat (&line[idx], &C))) break;
      idx+=maxdif;
      idx+=SkipSpaces (&line[idx]);
      if (!(maxdif=GetFloat (&line[idx], &D))) break;
      idx+=maxdif;
      idx+=SkipSpaces (&line[idx]);
      if (!(maxdif=GetFloat (&line[idx], &E))) break;
      idx+=maxdif;
      idx+=SkipSpaces (&line[idx]);
      if (!(maxdif=GetFloat (&line[idx], &F))) break;
      idx+=maxdif;
      idx+=SkipSpaces (&line[idx]);
      StrCopy (newname, &line[idx]);
      s=newname;
      while (*s<0 || *s>=' ') s++;
      *s=0;
    } while (0);      
    // recompute coordinates and compare if selected position is in this map
    new_rel_x=A*MapInfo.rel_pos_x+C*MapInfo.rel_pos_y+E;
    new_rel_y=B*MapInfo.rel_pos_x+D*MapInfo.rel_pos_y+F;
    err=StrLen (newname);
    if (new_rel_x>=0 && new_rel_x<=1 && new_rel_y>=0 && new_rel_y<=1 && *newname) {
      // look for this map name in VFSInfo.maplist
      for (idx=0; idx<VFSInfo.mapcount; idx++) {
        if (!StrNCaselessCompare (VFSInfo.maplist[idx]->name, newname, (VFSInfo.maplist[idx]->namelen>err)?VFSInfo.maplist[idx]->namelen:err)) {
          MapInfo.rel_pos_x=new_rel_x;
          MapInfo.rel_pos_y=new_rel_y;
          actpos=idx;
          if (err==VFSInfo.maplist[idx]->namelen) {
            // looking for appropriate zoom number: for ZOOM out the biggest, for ZOOM in the smallest
            for (actpos=idx; idx<VFSInfo.mapcount; idx++) {
              if (VFSInfo.maplist[idx]->index!=VFSInfo.maplist[actpos]->index) continue;
              if (step<0) { // ZOOM out
                if (VFSInfo.maplist[idx]->zoom>VFSInfo.maplist[actpos]->zoom)
                  actpos=idx;
              } else { // ZOOM in
                if (VFSInfo.maplist[idx]->zoom<VFSInfo.maplist[actpos]->zoom)
                  actpos=idx;
              }
            }
          }
          VFSFileClose (testfile);
          StrCopy (MapInfo.curr_map.name, VFSInfo.maplist[actpos]->name);
          MapInfo.curr_map.volRefNum=VFSInfo.maplist[actpos]->volRefNum;
          return 0;
        }
      }
      // if both conditions are true - new map is found...
    }
  }

  VFSFileClose (testfile);
  return 5;
}
#ifdef GPS_gonio
// ------------------------------------
// GPS to XY
// ------------------------------------
Err GPS2XY (GPSinfoType *pos) {
GPSinfoType *cal[3];
double dst[3], tmp;
UInt16 i, mi;
Char fls[80];
double x1, x2, y1, y2, c_lat, c_lon, re, re1, re2;
double rp, x, y, phi, z;
#define M_PI		3.14159265358979323846
#define gps_re1         6378137
#define gps_re2         6356752

  if (!MapInfo.GPScal || MapInfo.GPScount<3) return -1;
  // najdu dva nejblizsi kalibracni body (kazdy bod ma slozku GPS a XY, takze lze ze vzajemneho vztahu vypocitat meritko a natoceni
  dst[0]=dst[1]=dst[2]=1e10;
  cal[0]=cal[1]=cal[2]=NULL;
  for (mi=i=0; i<MapInfo.GPScount; i++) {
    tmp=hypot (pos->lat.d-MapInfo.GPScal[i].lat.d, pos->lon.d-MapInfo.GPScal[i].lon.d);
    if (tmp<dst[mi]) {
      dst[mi]=tmp;
      cal[mi]=&MapInfo.GPScal[i];
/**
      // najdu nejvetsi ze tri cisel
      if (dst[0]>dst[1]) {
        if (dst[0]>dst[2])
          mi=0;
        else
          mi=2;
      } else {
        if (dst[1]>dst[2])
          mi=1;
        else
          mi=2;
      }
**/
      // plnim jen dve cisla
      if (dst[0]>dst[1]) {
        mi=0;
      } else {
        mi=1;
      }
    } 
  }
  // zobrazeni nejblizsich bodu
  //for (i=mi=0; i<3; i++) {
  for (i=mi=0; i<2; i++) {
    FlpFToA (cal[i]->lat.fd, &fls[mi]);
    StrCat (fls, ", ");
    mi+=StrLen (&fls[mi]);
    FlpFToA (cal[i]->lon.fd, &fls[mi]);
    StrCat (fls, "; ");
    mi+=StrLen (&fls[mi]);
  }
  DEBUG (fls);
  // vypocet X,Y souradnic
  // pracovni promenne
  // zemsky polomer v obou kalibracnich bodech
  re1 = cal[0]->lat.d / 90 * gps_re2 + (1 - cal[0]->lat.d / 90) * gps_re1;
  re2 = cal[1]->lat.d / 90 * gps_re2 + (1 - cal[1]->lat.d / 90) * gps_re1;
  // stred kalibracnich bodu
  c_lat = (cal[0]->lat.d + cal[1]->lat.d) / 2;
  c_lon = (cal[0]->lon.d + cal[1]->lon.d) / 2;
/**
FlpFToA (*((FlpDouble*)&re1), fls);
StrCat (fls, ", ");
mi=StrLen (fls);
FlpFToA (*((FlpDouble*)&re2), &fls[mi]);
StrCat (fls, ", ");
mi=StrLen (fls);
FlpFToA (*((FlpDouble*)&c_lat), &fls[mi]);
StrCat (fls, ", ");
mi=StrLen (fls);
FlpFToA (*((FlpDouble*)&c_lon), &fls[mi]);
DEBUG (fls);
**/
  // zemsky polomer stredu kalibracnich bodu
  re = c_lat / 90 * gps_re2 + (1 - c_lat / 90) * gps_re1;
  // jakasi vzdalenost kalibracnich bodu x,y od stredu kalibracnich bodu
  y1 = M_PI / 180 * re * (cal[0]->lat.d - c_lat);
  y2 = M_PI / 180 * re * (cal[1]->lat.d - c_lat);
  x1 = cos(M_PI / 180 * cal[0]->lat.d) * M_PI / 180 * re1 * (cal[0]->lon.d - c_lon);
  x2 = cos(M_PI / 180 * cal[1]->lat.d) * M_PI / 180 * re2 * (cal[1]->lon.d - c_lon);
/**
FlpFToA (*((FlpDouble*)&y1), fls);
StrCat (fls, ", ");
mi=StrLen (fls);
FlpFToA (*((FlpDouble*)&y2), &fls[mi]);
StrCat (fls, ", ");
mi=StrLen (fls);
FlpFToA (*((FlpDouble*)&x1), &fls[mi]);
StrCat (fls, ", ");
mi=StrLen (fls);
FlpFToA (*((FlpDouble*)&x2), &fls[mi]);
DEBUG (fls);
**/
  // zemsky polomer v zadanem GPS bodu
  rp = pos->lat.d / 90 * gps_re2 + (1 - pos->lat.d / 90) * gps_re1;
  // x,y vzdalenost zadaneho GPS bodu od stredu kalibracnich bodu
  y = M_PI / 180 * re * (pos->lat.d - c_lat);
  x = cos(M_PI / 180 * pos->lat.d) * M_PI / 180 * rp * (pos->lon.d - c_lon);
/**
FlpFToA (*((FlpDouble*)&re), fls);
StrCat (fls, ", ");
mi=StrLen (fls);
FlpFToA (*((FlpDouble*)&rp), &fls[mi]);
StrCat (fls, ", ");
mi=StrLen (fls);
FlpFToA (*((FlpDouble*)&y), &fls[mi]);
StrCat (fls, ", ");
mi=StrLen (fls);
FlpFToA (*((FlpDouble*)&x), &fls[mi]);
DEBUG (fls);
**/

  phi = atan2(y1 - y2, x1 - x2);
FlpFToA (*((FlpDouble*)&phi), fls);
StrCat (fls, ", ");
mi=StrLen (fls);
  phi = atan2(cal[0]->y.d - cal[1]->y.d, cal[0]->x.d - cal[1]->x.d);
FlpFToA (*((FlpDouble*)&phi), &fls[mi]);
StrCat (fls, ", ");
mi=StrLen (fls);
  z = hypot(cal[0]->y.d - cal[1]->y.d, cal[0]->x.d - cal[1]->x.d);
FlpFToA (*((FlpDouble*)&z), &fls[mi]);
StrCat (fls, ", ");
mi=StrLen (fls);
  z = hypot(y1 - y2, x1 - x2);
FlpFToA (*((FlpDouble*)&z), &fls[mi]);
DEBUG (fls);

  // uhel natoceni mezi GPS kalibraci a x,y souradnicemi mapy
  phi = atan2(y1 - y2, x1 - x2) - atan2(cal[0]->y.d - cal[1]->y.d, cal[0]->x.d - cal[1]->x.d);
  // meritko prepoctu mezi GPS a x,y souradnicemi
  z = hypot(cal[0]->y.d - cal[1]->y.d, cal[0]->x.d - cal[1]->x.d) / hypot(y1 - y2, x1 - x2);
  // vypocet finalnich x,y souradnic
  pos->x.d = z * cos(phi) * (x - x1) + z * sin(phi) * (y - y1) + cal[0]->x.d;
  pos->y.d = -z * sin(phi) * (x - x1) + z * cos(phi) * (y - y1) + cal[0]->y.d;
FlpFToA (*((FlpDouble*)&phi), fls);
StrCat (fls, ", ");
mi=StrLen (fls);
FlpFToA (*((FlpDouble*)&z), &fls[mi]);
StrCat (fls, ", ");
mi=StrLen (fls);
FlpFToA (pos->x.fd, &fls[mi]);
StrCat (fls, ", ");
mi=StrLen (fls);
FlpFToA (pos->y.fd, &fls[mi]);
DEBUG (fls);
  
  return 0;
}
// ------------------------------------
// XY to GPS
// ------------------------------------
Err XY2GPS (GPSinfoType *pos) {
GPSinfoType *cal[3];
double dst[3], tmp;
UInt16 i, mi;
Char fls[80];
double x1, x2, y1, y2, c_lat, c_lon, re, re1, re2;
double rp, x, y, phi, z;

  if (!MapInfo.GPScal || MapInfo.GPScount<3) return -1;
  // najdu tri nejblizsi kalibracni body
  // pry staci jen dva...
  dst[0]=dst[1]=dst[2]=1e10;
  cal[0]=cal[1]=cal[2]=0;
  for (mi=i=0; i<MapInfo.GPScount; i++) {
    tmp=hypot (pos->x.d-MapInfo.GPScal[i].x.d, pos->y.d-MapInfo.GPScal[i].y.d);
    if (tmp<dst[mi]) {
      dst[mi]=tmp;
      cal[mi]=&MapInfo.GPScal[i];
      // najdu nejvetsi ze tri cisel
      if (dst[0]>dst[1]) {
        if (dst[0]>dst[2])
          mi=0;
        else
          mi=2;
      } else {
        if (dst[1]>dst[2])
          mi=1;
        else
          mi=2;
      }
    } 
  }
  // zobrazeni nejblizsich bodu
  for (i=mi=0; i<3; i++) {
    FlpFToA (cal[i]->x.fd, &fls[mi]);
    StrCat (fls, ", ");
    mi+=StrLen (&fls[mi]);
    FlpFToA (cal[i]->y.fd, &fls[mi]);
    StrCat (fls, "; ");
    mi+=StrLen (&fls[mi]);
  }
  DEBUG (fls);
  // vypocet GPS souradnic
  // potrebne hodnoty
/**
  c_lat = (p1.lat + p2.lat) / 2;
  c_lon = (p1.lon + p2.lon) / 2;
  c.x = (p1.x + p2.x) / 2;
  c.y = (p1.y + p2.y) / 2;
  re1 = p1.lat / 90 * gps_re2 + (1 - p1.lat / 90) * gps_re1;
  re2 = p2.lat / 90 * gps_re2 + (1 - p2.lat / 90) * gps_re1;
  re = c.lat / 90 * gps_re2 + (1 - c.lat / 90) * gps_re1;
  y1 = M_PI / 180 * re * (p1.lat - c.lat);
  y2 = M_PI / 180 * re * (p2.lat - c.lat);
  x1 = cos(M_PI / 180 * p1.lat) * M_PI / 180 * re1 * (p1.lon - c.lon);
  x2 = cos(M_PI / 180 * p2.lat) * M_PI / 180 * re2 * (p2.lon - c.lon);
**/
  c_lat = (cal[0]->lat.d + cal[1]->lat.d) / 2;
  c_lon = (cal[0]->lon.d + cal[1]->lon.d) / 2;
  re1 = cal[0]->lat.d / 90 * gps_re2 + (1 - cal[0]->lat.d / 90) * gps_re1;
  re2 = cal[1]->lat.d / 90 * gps_re2 + (1 - cal[1]->lat.d / 90) * gps_re1;
  re = c_lat / 90 * gps_re2 + (1 - c_lat / 90) * gps_re1;
  y1 = M_PI / 180 * re * (cal[0]->lat.d - c_lat);
  y2 = M_PI / 180 * re * (cal[1]->lat.d - c_lat);
  x1 = cos(M_PI / 180 * cal[0]->lat.d) * M_PI / 180 * re1 * (cal[0]->lon.d - c_lon);
  x2 = cos(M_PI / 180 * cal[1]->lat.d) * M_PI / 180 * re2 * (cal[1]->lon.d - c_lon);
  // nasledne vypocty
  phi = atan2 (cal[0]->y.d - cal[1]->y.d, cal[0]->x.d - cal[1]->x.d) - atan2(y1 - y2, x1 - x2);
  z = hypot(y1 - y2, x1 - x2) / hypot(cal[0]->y.d - cal[1]->y.d, cal[0]->x.d - cal[1]->x.d);
  x = z * cos(phi) * (pos->x.d - cal[0]->x.d) + z * sin(phi) * (pos->y.d - cal[0]->y.d) + x1;
  y = -z * sin(phi) * (pos->x.d - cal[0]->x.d) + z * cos(phi) * (pos->y.d - cal[0]->y.d) + y1;
  pos->lat.d = y / M_PI * 180 / re + c_lat;
  rp = pos->lat.d / 90 * gps_re2 + (1 - pos->lat.d / 90) * gps_re1;
  pos->lon.d = x / cos(M_PI / 180 * pos->lat.d) / M_PI * 180 / rp + c_lon;

  return 0;
}
#endif
#ifdef GPS_linear
static Int16 SolveLin (double lin[3][3]) {
Int16 i, j;
/*
double deter, da, db, dc;
  deter=lin[0][1]*lin[1][2]+lin[0][2]*lin[2][1]+lin[1][1]*lin[2][2]-lin[2][1]*lin[1][1]-lin[2][2]*lin[0][1]-lin[1][1]*lin[0][2];
  if (!deter) return -1;
  da=
  db=
  dc=
**/
  // odectu posledni radek od prvnich dvou
  for (i=0; i<2; i++)
    for (j=0; j<3; j++)
      lin[i][j]-=lin[2][j];
  // normuju oba radky podle [][2]
  for (i=0; i<2; i++)
    for (j=0; j<3; j++)
      lin[i][j]/=lin[i][2];
  // odectu druhy radek od prvniho
  for (i=0; i<3; i++)
    lin[0][i]-=lin[1][i];
  // normuju prvni radek
  for (i=0; i<2; i++)
    lin[0][i]/=lin[0][1];
  // pocitam jednotlive koeficienty
  //lin[0][0] = A;
  lin[1][0]-=lin[0][0]*lin[1][1];
  lin[2][0]-=lin[0][0]*lin[2][1]+lin[1][0]*lin[2][2];
  return 0;
}
// ------------------------------------
// GPS to XY
// ------------------------------------
Err GPS2XY (GPSinfoType *pos) {
GPSinfoType *cal[3];
double lin[3][3];
double coef[2][3];
Int16 i, j, mi;
Char fls[120];
  // beru body 1, 3, 7 - takze 0, 2, 6
  cal[0]=&MapInfo.GPScal[0];
  cal[1]=&MapInfo.GPScal[2];
  cal[2]=&MapInfo.GPScal[6];
/**
  for (i=mi=0; i<3; i++) {
    FlpFToA (cal[i]->lat.fd, &fls[mi]);
    StrCat (fls, ", ");
    mi+=StrLen (&fls[mi]);
    FlpFToA (cal[i]->lon.fd, &fls[mi]);
    StrCat (fls, "; ");
    mi+=StrLen (&fls[mi]);
  }
  DEBUG (fls);
**/
  // vypocitam dve soustavy 3 linearnich rovnic
  // nejprve koeficienty pro X
  for (i=0; i<3; i++) {
    lin[i][0]=cal[i]->x.d;
    lin[i][1]=cal[i]->lon.d;
    lin[i][2]=cal[i]->lat.d;
  }
  if (SolveLin (lin)) return -1;
  coef[0][0]=lin[0][0];
  coef[0][1]=lin[1][0];
  coef[0][2]=lin[2][0];
  // ted koeficienty pro X
  for (i=0; i<3; i++) {
    lin[i][0]=cal[i]->y.d;
    lin[i][1]=cal[i]->lon.d;
    lin[i][2]=cal[i]->lat.d;
  }
  if (SolveLin (lin)) return -1;
  coef[1][0]=lin[0][0];
  coef[1][1]=lin[1][0];
  coef[1][2]=lin[2][0];

  for (i=mi=0; i<2; i++) {
    for (j=0; j<3; j++) {
      FlpFToA (*((FlpDouble*)&coef[i][j]), &fls[mi]);
      StrCat (fls, ", ");
      mi+=StrLen (&fls[mi]);
    }
  }
  DEBUG (fls);

  // prepocet zadane GPS pozine na XY
  pos->x.d = pos->lon.d*coef[0][0]+pos->lat.d*coef[0][1]+coef[0][2];
  pos->y.d = pos->lon.d*coef[1][0]+pos->lat.d*coef[1][1]+coef[1][2];
  return 0;
}
// ------------------------------------
// XY to GPS
// ------------------------------------
Err XY2GPS (GPSinfoType *pos) {
GPSinfoType *cal[3];
  return 0;
}
#endif
