/*************************************
 MapView 1.1
 (C) 2004-2007 Hynek Sladky
 sladky@mujmail.cz
*************************************/

#define ALLOW_ACCESS_TO_INTERNALS_OF_BITMAPS
#define ALLOW_ACCESS_TO_INTERNALS_OF_FORMS
#define ALLOW_ACCESS_TO_INTERNALS_OF_WINDOWS
// ------------------------------------
// PalmOS standard include files
// ------------------------------------
#include <PalmOS.h>
#include <ExpansionMgr.h>
#include <VFSMgr.h>
#include <PalmChars.h>
#include <LibTraps.h>
// ------------------------------------
// Sony HiRes support
// ------------------------------------
#include <Sony\SonyCLIE.h>
// ------------------------------------
// ZLib de/compression support
// ------------------------------------
#include "SysZLib.h"
// ------------------------------------
// LZO de/compression support
// ------------------------------------
#include "lzo1x.h"
// ------------------------------------
// MathLib support
// ------------------------------------
#include "MathLib.h"
// ------------------------------------
// application header
// ------------------------------------
#include "MapView.h"
#include "MapFunc.h"
// ------------------------------------
// resources header
// ------------------------------------
#include "MapViewR.h"
// ------------------------------------
// AutoVer support
// ------------------------------------
#include "version.h"
extern char *build, *build_date, *build_time;

/******** ToDo ********/
/**********************
OPRAVY CHYB:
============
- opravit chybu pri skoku na POI
  POI je v SHC_1 (Jablonec)
  zoom do SHC_3 a goto POI (Jablonec) skoci k Novemu Boru
  -> zpracovani mapPOI eventu
- ve funkci DrawBitmap spravne pouzit MapInfo.valid
  resp. pouzit to vsude, kde to ma opodstatneni
    kdyz jsem smazal mapy, tak se hodilo deleni nulou!!
? zmena ZOOMovani: pokud se zoomuje do superdlazdice, tak se prida cyklus, ktery zjistuje, zda nektery ZOOM obsahuje dlazdici, ktera pozadovany bod obsahuje
- pokud v souboru .BML zadam, ze se ma zoomovat do urciteho cisla (napr. SHC_TC50t_1), tak se cislo stejne nepouzije! a zoomuje se do SHC_TC50t_0 :-(
  BML soubor se ukazuje s flagem LinkFlag
  funkce TestFile v MapFunc.c:
  -> pokud je nazev zadan konkretne, tak nehledam jine ZOOMnumber pro danou mapu! - resi to pro vyjmenovane pripady...
  -> lepsi by bylo zjistit meritko dane mapy a jit do takoveho ZOOMnumber, kdy je meritko vetsi/mensi podle smeru...
     problem je, ze v BML souboru neni informace o meritku mapy...
  -> tak jsem to 'nejak' upravil a zjistil jsem, ze mi stejne nevyhovuje krok pres SHC_TC50t_0, tak jsem ji smazal a tuto upravu (zatim) nepotrebuju

UPRAVY, NOVE FUNKCE:
=======
- funkce azimut+vzdalenost
- pri vyberu POI apod se misto vzdalenosti zobrazi do stejneho okna vyzva k zadani prvniho bodu
  DistanceWindow
  RedrawDistance -> ruzne funkce podle stavu/rezimu zadavani bodu
  - funkce:
    Set/End route - zobrazi okno a umozni zadat prvni a dalsi body
    Add/End route - zobrazi okno a umozni pridavat body
    Add POI - nic nezobrazi, jen ceka... -> zobrazit okno s informaci (treba zatim jen vzdalenost)
- rozdelit program na UI a ostatni
  definice struktur apod. do hlavickoveho souboru
  prototypy spolecnych funkci do hlavickoveho souboru
o aktualni pozadavek:
  o pro geocaching upravit POI tak, aby se pamatovala presna pozice a aby tuto presnou pozici dokazal vykreslit
    to by znamenalo upravu pouziti historyType v pripade POI: startX, Y nebudou pozice leveho rohu, ale pozice bodu
    po skoku na tuto pozici se musi vykreslit bod na LCD
  o prikaz pro vykresleni vsech POI na soucasne mape
  - opravit pripocetni offsetu pri necelych posunech (viz SIM T5)
    projit si zpracovani xOff, yOff, xRest, yRest
  - v SETUP mit moznost zobrazovat POI trvale
    tj. asi pri kazdem posunu a prekresleni se musi znova projit POI databaze
    pripadne mit k dispozici pole s aktualnimi POI v aktualni mape
  - pokud mozno, tak si pamatovat relativni polohu a pak ji aplikovat na cele sade map
- zatim omezena podpora GPS:
  - prikaz na nacteni GPS kalibrace z jednotlivych map
  - ulozeni do databaze (MapView.gps) 'GPSc'
  - pri prechodech mezi mapami se pouzivaji GPS souradnice
  - rusi se mapview.bml
- podpora pro GPS prijimac
  vyber seriove linky, rychlosti apod.
  vypnuti displaye: REM sleep v Examples; _not_archived_\LCD_armlet.zip
  (Deferred) sleep: sysNotifySleepRequestEvent
    ((SleepEventParamType*)(((SysNotifyParamType*)cmdPBP)->notifyDetailsP))->deferSleep++;
  REMsleep: hsNotifyRemSleepRequestEvent
    ((SleepEventParamType*)(((SysNotifyParamType*)cmdPBP)->notifyDetailsP))->deferSleep++;
  take se musi registrovat pro notifikaci kPalmCreatorIDLcdState
    if (((SysNotifyParamType*)cmdPBP)->notifyDetailsP) {
      // disable keyguard
      active=0;
      HsAttrSet (hsAttrKeyboardLocked, 0, active);
      // stop timer and alert user
      // ...???
    }
  mozna by zatim stacilo udelat nejakou podporu do MultiLauncher pro vypnuti podsviceni LCD... ???
  jenze to by si muselo pamatovat, ze je podsviceni docasne vypnute a pak ho zas zapnout
  takze by asi bylo vhodnejsi udelat podporu pro REM sleep, ktery jaksi sam od sebe vypne podsviceni i displej, ale procesor data zpracovava...
- zoomovani:
    pokud je polozka v zoomlistu a vyhovuje pozice, jde se podle zoomlistu
    hleda se v mapach podle GPS, kde je dany bod obsazeny, a podle meritka (in: vetsi, out: mensi)
    pokud je vice map, kde je dany bod obsazeny, zobrazi se listbox s vyberem CR -> turisticka/mesto apod.
- tj. musim si (treba na vyzadani) vytvorit databazi GPS kalibraci, map a jejich meritek
    pro kazdou sadu map bude jeden zaznam s vice polozkama ohledne zoomovaciho cisla a meritka
- jako prvni tedy bude pridani kalibracnich bodu do vsech pozadovanych bmd, jejich nacteni a zapsani do databaze
  utilita pro bmd_tag_to_txt a txt_to_bmd_tag
- podpora pro geocaching
  POI obsahuje i textovou poznamku s moznosti editace
  obsahuje casovy zaznam: asi staci 'kdy bylo nalezeno'
  - zkusit se podivat po strukture databaze CacheMate: bylo by dobre toto pouzit at uz jako import nebo lepe jako vlastni databazi
    nakonec by se tam mohly pridavat POI (treba do urcite databaze se specifickym jmenem ale se stejnou strukturou...)
- moznost zapnuti HW tlacitky (je-li vypnute a doslo ke stisku HW tlacitka, ktere je namapovane na akci, tak se akce nevykona, tj. Palm se jen zapne)
- dusledna kontrola ctvercovych dlazdic pri rotaci -> LCDrotate=0...
  nebo pro nectvercovou rotaci vytvorit pomocny prostor...
  MemPtrNew
  MemMove
  rotace v 'jednoduchem' dvojitem cyklu
- pozadavek na lupu
  jednorazove prekresleni displeje - musi byt rucne kvuli lowres
  pak se nastavi flag, ktery pri posunu prekresli cely display...
  uplne idealni by bylo zkopirovat ctvrtinu displeje v 8bpp a tu pak prekreslit opet jako 8bpp
  POZOR! musim podporovat i 16bpp, protoze to podporuju... :-)
  ale jeste POZOR! pokud kreslim 8bpp, tak LCD muze byt klidne 4bpp, takze to musim nejak jeste premyslet...


NAMETY, STUDIUM:
=======
- podivat se, proc v kazde mape dostanu jiny vysledek...
  kalibracni body: [50.803319, 14.981517] a [50.732644, 14.984422]
  vysledek 0 (2563x1938 | 33x25): {0.01492683, 0.1064127}
  vysledek 1: (5125x3938 | 65x50): {0.01492683, 0.1064127}
  vysledek 2: (10250x7875 | 129x99): {0.01492683, 0.1064127}
  spravny vysledek: {0.01492683,0.10641270}
  -> vysledek je vypocitany spravne!!! Ale zobrazi se spatne!!!
     bud je spatne pripravena bitmapa => musim rict Jirkovi o PNG soubory a zkontrolovat, zda se relativni poloha danych bodu shoduje!
     nebo spatne probehne prepocet na absolutni polohu v bitmape
- multigen by byl dobry, protoze sam provede analyzu, ale podle data to asi nebude nejcerstvejsi...
  budu si muset stahnout PODS a podivat se, jak je to tam resene
  podle zminek na palm-dev se segmenty definuji rucne... Asi to je lepsi, mel bych tak plny prehled,
  ale take to je narocnejsi, nez kdyby si multigen toto zpracoval a urcil sam...
  - pro hledani pouzit slova segment nebo section
  asi se budu muset vratit k puvodnimu konceptu rucniho rozdeleni do segmentu...
  - peclive si projit, jak to rozdelit...
  taky nevim, jak to udelat s knihovnama pro volani zlib a lzo, tak budu muset se zeptat na konferenci, jak to provest...
  ale nejdriv prostudovat dokumentaci, kterou jsem si zapsal do sections.txt
  -> nejlepsi bude rozdelit funkce podle urciteho zamereni: sektor pro UI, sektor pro bitmapy apod. - tak si v celem projektu aspon udrzim prehled...
     jen to bude chtit jednotny pristup, jak a kde presne definovat sektory, protoze nektere funkce jsou static, tak by nemely byt v .h


HOTOVO:
=======
Zkontrolovat:
-------------
o zoomin/out v cartoon: skocit na [0,0]
o posun mapy tak, aby se pri dalsim kroku posunovala vzdy o celou dlazdici
  napr. u HiRes+ nebo u rozmeru jineho nez 80 bodu (napr. 100 bodu)
  tj. asi si zavest nejaky offset a s nim soupat tak, aby se prekresloval vzdy prave jeden pruh dlazdic (a ne dva, jak se to deje ted)
  Ten offset se podstrci funkci ShowBitmaps... -> hledat funkci ShowBitmaps a pochopit souradnice leveho rohu; vetsinou 0,0
  Bude treba to propojit s .incompleteX a .incompleteY aby se tyto promenne nastavovaly a nulovaly dle meziposunu...?
  Nebo jeste jinak: je-li incompleteY a offsY=0 a je posun dolu, tak offs=cosi, posun o cosi; jinak posun o dlazdici.
  Tj. projit si posuny a modifikovat je...
  Asi nejlepe vytisknout (aspon klicove pasaze) a oznacit si mista modifikaci
  -> toto vyresil Jirka vlastni upravou...
o rotace se uklada divne: kdyz se nevleze do setupu, tak se neulozi
  - bylo by dobre, kdyby byl program po opetovnem zapnuti presne v tom stavu, ve kterem se koncil...
  -> tj. ukladat rotaci pri kazdem vypnuti...
x problem je, ze vsechny funkce pouzivaji vsechny globalni promenne...
  budu si muset nejdriv nejak (jak?) utridit, jake jsou vazby mezi funkcemi
  - viz utilita ..\ostatni\inspect a vystupni soubor mapview.tree
  -> tisk mapview.tree
  pak si utridim, jake jsou vazby z funkci na globalni promenne
o blokovani attention manageru
  AttnIndicatorEnable (false)
o udelat poradek v ToDo
  rozdelit na ToDo (nutne), ToDo (planovane), napady/namety
x zamyslet se nad pridavanim POI
  neni zrejme, co se ma udelat - pridat popis do HELPu nebo alert "tap to add point"
? historie: seznam map, ve kterych jsem se pohyboval (tj. posledni pozice v naposled zobrazenem zoomovem cisle)
  zoomlist: seznam map i zoomovych cisel, jak jsem se pohyboval
    pokud chci zoom in/out, jdu primarne podle tohoto seznamu, pokud je vybrana pozice stale obsazena ve vybrane mape
    jinak se zbytek seznamu v danem smeru smaze a vytvari se znova...
x kazda mapa bude mit nastavitelnou kategorii
  kdyz budu v mape, muzu ji zmenit kategorii
  nebo listbox s mapama a u nich menit kategorii? - slozite - listbox by musel zobrazit dalsi listbox...
? zkusit u listboxu s checkboxy nechat listbox zobrazeny, dokud nekliknu mimo listbox...
  - tedy jestli to pujde?
? .bitdata_ se uz nepouziva pro rozhodovani, asi by mel byt jen jeden!!
  pro 8/16 bit pristup pouzivat jen jeden ukazatel a pretypovani...
? mozna by se hodilo udelat pravou funkci pro tisk rotovane bitmapy...
  bylo by vsak potreba
  a) podporovat ruzne bitove hloubky
  b) mit callback pro prevod z 8bit (ta je vzdy vstupni!) na pozadovanou mezi rotaci a tiskem
  nebo
    mit dve funkce
      1. rotace (tak, ze prohodi sirku a vysku)
      2. tisk (podobny PalmOS API), s pridavkem rotace...
    toto by bylo zrejme nejuniverzalnejsi...
      jen bude potreba zarucit, ze nebude potreba rotovat jinou nez 8-bit bitmapu...
x rozdeleni do segmentu - z linkeru si nechat vypsat strom volani funkci...
  zatim jsem nenasel zadnou volbu, jak ho k tomu donutit...
  neco jsem sepsal rucne - viz konec zdrojaku...
x lepe vyresit cekani pri detekci dlouheho stisku
  soucasny stav neumoznuje stisknout 5way sikmo (dve soucasne stisknuta tlacitka...)
  ono to asi nebude tim cekanim, ale T|E pri soucasnem stisku prestane generovat pageup/pagedown, a generuje jen vchrNavChange
    tak bych musel udelat nejaky inteligentni algoritmus, ktery by za jistych okolnosti misto PageUp bral vchr...
    napriklad pokud je autoRepeatKeyMask, tak 5way handling bude krome RockerL/R generovat PageUp/Down... ?
  mozna bych mohl ignorovat vchrPageUp/Down, ale pak to nebude fungovat na jinych zarizenich...
  nebo jinak: z vchrPageUp/Down pregenerovat RockerUp/Down; pri repeat vchrNavChange vygenerovat pri vice stisknutych tlacitkach vchrRockerUp/Down
  nebo zas jinak: nechat PageUp/Down, ale pri vchrNavChange a vice nastavenych bitech se postarat o generovani vchrPageUp/Down...
  bylo by take dobre zjistit, zda na T5 lze soucasny stisk L/R+U/D a co se vlastne generuje...
? bylo by rozumne pri kazdem keyDown, ktery nezpracuju, si poznamenat klidovy stav KeyStates
  jen nevim, aby to pak nevedlo k problemum...
  moznym resenim by bylo nejakym chytrym algoritmem zjistovat, ze doslo/nedoslo k pusteni...
    treba pokud se stav nezmeni od zacatku sledovani...
    pokud se zmeni - pustenim tlacitka...
    -> cekam bud na zmizeni aspon 1 bitu nebo po dobu zpozdeni autorepeat
? power-off se (nekdy) nenuluje pri stisku tlacitek...
  nevim, ktera vsechna tlacitka... je mozne, ze by stacilo doplnit tuto akci ke kliknuti...
x Graffiti 2
  pokud jsou znaky 'l', ' ', '\'', '-'
    je potreba cekat, zda nebude BackSpace a jiny znak...
x pokud nepujde jinak ("Prefs"), tak mozna udelat podporu pro zustani v zapnutem stavu, je-li nabijecka pripojena...
x pri posunu za okraj zkusit hledat v ZoomIn/ZoomOut???
  jeste poradne promyslet...

***********************/
// ====================================
// DEBUG alert support
// ------------------------------------
#include <stdarg.h>
void DEBUG (char *a, ...) {
char *b = MemPtrNew(256);
va_list p;
  va_start(p, a);
  StrVPrintF(b, a, p);
  FrmCustomAlert (show, b, "", "");
  va_end(p);
  MemPtrFree(b);
}
// ====================================
// compile control
// ------------------------------------
//#define force16bpp
//#define CopyNames
// ====================================
// global variables
// ------------------------------------
// supported keyDown buttons - this array maps keys to enum_buttons
// ------------------------------------
const WChar known_buttons[btn_count/2]={
  vchrHard1,
  vchrHard2,
  vchrHard3,
  vchrHard4,
  vchrPageUp,
  vchrPageDown,
  vchrRockerLeft,
  vchrRockerRight,
  vchrRockerCenter,
  vchrJogUp,
  vchrJogDown,
  vchrJogRelease,
  vchrJogBack
};
UInt8 keypresscnt[btn_count/2];
// ------------------------------------
// command bar icon IDs
// ------------------------------------
BarIconType cmdbaricons[]={
  {bitmapOpen, menu_openmap},
  {bitmapTop, menu_top},
  {bitmapZoomOut, menu_zoomout},
  {bitmapCenter, menu_center},
  {bitmapOverview, menu_overview},
  {bitmapHistory, menu_history},
  {bitmapPOIs, menu_POI},
  {bitmapRoute, menu_setroute},
  {bitmapGrid, menu_grid},
  {bitmapRotLeft, menu_rotateL},
  {bitmapRotRight, menu_rotateR},
  {bitmapInfo, menu_info},
  {0, 0}
};
// ------------------------------------
// preference type
// ------------------------------------
PrefsType Prefs = {
  {Grid_mask|Root_only, 0, 0, 0, 0, 
    {0x00, 0x99, 0x99, 0x99},
    {0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 7, 0, 1, 0, 2, 0, 10, 0, 0, 0},
//    {0, 0, 3, 0, 4, 0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 7, 0, 0, 1, 0, 2, 0, 10, 0, 0, 0}, // for DEBUG on PC - I am not able find 5way controls in simulator :-(
   0.0, 1.0, 0
  }, {"/PALM/Programs/MapView/", "", "", "", "px"}};
UInt32          oldflags;
// ------------------------------------
// History Database
// ------------------------------------
DmOpenRef       histDB;
// ------------------------------------
// LCD variables
// ------------------------------------
LCDinfoType LCD;
// ------------------------------------
// VFS directory entries
// ------------------------------------
VFSinfoType VFSInfo;
// ------------------------------------
// actual map information
// ------------------------------------
MapInfoType MapInfo;
// ------------------------------------
// drawing space variables
// ------------------------------------
DrawInfoType DrawInfo;
// ------------------------------------
// other global variables
// ------------------------------------
// hard buttons enable flag
UInt8           hardEnable;
// distance window
WinHandle       win_dist;
// info form title
Char infoTitle[64];
// point selection variable
selPointType selectPoint;
// ------------------------------------
// PointOfInterest variables
// ------------------------------------
DmOpenRef       POI_DB;
POItype         POI;
// ====================================
// function prototypes
// ------------------------------------
UInt16 StrDistance (Char *str, double val);
// ------------------------------------
// set LCD to desired color depth
// ------------------------------------
void SetLCDmode (UInt8 bpp) {
UInt32  mask, val;

  if (bpp==LCD.bits) return;
  mask=1<<(bpp-1);
  val=bpp;
  while (!(mask&LCD.modes)) {mask>>=1; val--;}
  if (val>1 && val!=LCD.bits) {
    LCD.bits=val;
    if (LCD.sonyHiResRefNum==sysInvalidRefNum)
      WinScreenMode (winScreenModeSet, NULL, NULL, &LCD.bits, NULL);
    else
      HRWinScreenMode (LCD.sonyHiResRefNum, winScreenModeSet, NULL, NULL, &LCD.bits, NULL);
  }
}
// ------------------------------------
// setting of file's flags and variables for fast zoom search
// flags | name len (w/o number and extension) | map number | zoom number
// ------------------------------------
Boolean GetFilenameFlags (Char *name, UInt16 idx) {
UInt8	flags;
UInt16	number, i, j;

  flags=0;
  i=0;
  // looking for '.' - multiple dots not supported!
  while (name[i] && name[i]!='.') i++;
  // check name format
  // refuse no name or name beginning w/ dot
  if (!i) return false;
  // refuse name w/o extension
  if (name[i]!='.') return false;
  // refuse name w/ incorrect (unsupported) extension
  if ((name[i+1]&0xDF)!='B' || (name[i+2]&0xDF)!='M' || ((name[i+3]&0xDF)!='D' && (name[i+3]&0xDF)!='L')) return false;
  // MapView.BML allowed only...
  if ((name[i+3]&0xDF)=='L') {
    if (StrCaselessCompare (name, "mapview.bml"))
      return false;
    VFSInfo.linkindex=idx;
    flags|=LinkFlag;
  }
  number=0;
  // go through the number in reverse order
  while (i && name[i-1]>='0' && name[i-1]<='9') i--;
  j=i;
  // get ZOOM number
  while (name[i]>='0' && name[i]<='9') {number*=10; number+=name[i]-'0'; i++;}
  if (VFSInfo.maplist==NULL) return true;
  // create new record for maplist
  VFSInfo.maplist[idx]=MemPtrNew (sizeof (direntry)+StrLen (name));
  if (VFSInfo.maplist[idx]==NULL) return false; // I don't know another way of safe behaviour
  VFSInfo.maplist[idx]->flags=flags;
  VFSInfo.maplist[idx]->zoom=number;
  VFSInfo.maplist[idx]->namelen=j;
  VFSInfo.maplist[idx]->volRefNum=VFSInfo.volRefNum;
  StrCopy (VFSInfo.maplist[idx]->name, name);
  // try to find the same name
  for (i=j=0; i<idx; i++) {
    if (VFSInfo.maplist[i]->index>j) j=VFSInfo.maplist[i]->index;
    if (VFSInfo.maplist[idx]->namelen!=VFSInfo.maplist[i]->namelen) continue;
    if (!StrNCaselessCompare (VFSInfo.maplist[idx]->name, VFSInfo.maplist[i]->name, VFSInfo.maplist[idx]->namelen)) {
      VFSInfo.maplist[idx]->index=VFSInfo.maplist[i]->index;
      return true;
    }
  }
  VFSInfo.maplist[idx]->index=j+1;
  return true;
}
// ------------------------------------
// Loading VOLUME/DIRECTORY entries
// ------------------------------------
void GetDirEntry (UInt16 cnt) {
Char            filename[256];
FileInfoType    info;
UInt16          idx, idx2;
UInt16          maxlen, zoompos;
Err             err;

  // check starting condition
  if (VFSInfo.DirectoryOK) return;
  if (VFSInfo.volIterator==vfsIteratorStop && !VFSInfo.DIRref) {
    // release unused memory
    if (VFSInfo.mapcount<MaxDIRentries) MemPtrResize (VFSInfo.maplist, VFSInfo.mapcount*sizeof (direntry*));
    // creating list for open dialog
    VFSInfo.openlist=MemPtrNew (VFSInfo.mapcount*sizeof (Char*));
    if (VFSInfo.openlist==NULL) return;
    // go through maps and set root_map flag
    // every index has only one map with root_map
    // find max index
    for (maxlen=idx=0; idx<VFSInfo.mapcount; idx++) {
      if (VFSInfo.maplist[idx]->index>maxlen) maxlen=VFSInfo.maplist[idx]->index;
    }
    for (idx2=0; idx2<=maxlen; idx2++) {
      // find first index item except for BML files
      for (idx=0; idx<VFSInfo.mapcount; idx++)
        if (VFSInfo.maplist[idx]->index==idx2) break;
      if (idx>=VFSInfo.mapcount) continue;
      zoompos=idx;
      for (; idx<VFSInfo.mapcount; idx++) {
        if (VFSInfo.maplist[idx]->index!=idx2) continue;
        if (VFSInfo.maplist[idx]->zoom<VFSInfo.maplist[zoompos]->zoom) zoompos=idx;
      }
      if (zoompos>=VFSInfo.mapcount) continue;
      VFSInfo.maplist[zoompos]->flags|=root_map;
    }
    // openlist will be (re)assigned before displaying it
    // DirectoryOK
    VFSInfo.DirectoryOK=1;
    return;
  }
  if (!VFSInfo.DIRref && VFSInfo.volIterator!=vfsIteratorStop) {
    // looking for next volume w/ selected directory
    err = VFSVolumeEnumerate (&VFSInfo.volRefNum, &VFSInfo.volIterator);
    if (err==errNone) {
      err = VFSFileOpen (VFSInfo.volRefNum, Prefs.str[homedir], vfsModeRead, &VFSInfo.DIRref);
      VFSInfo.dirIterator=vfsIteratorStart;
    }
  }
  if (!VFSInfo.DIRref) return;
  info.attributes=0;
  info.nameP=filename;
  info.nameBufLen=256;
  while (cnt && VFSInfo.dirIterator!=vfsIteratorStop) {
    err = VFSDirEntryEnumerate (VFSInfo.DIRref, &VFSInfo.dirIterator, &info);
    if (VFSInfo.mapcount<MaxDIRentries && err==errNone) {
      if (!(info.attributes & (vfsFileAttrDirectory | vfsFileAttrVolumeLabel | vfsFileAttrSystem | vfsFileAttrHidden))) {
        if (GetFilenameFlags (filename, VFSInfo.mapcount)) {
	  VFSInfo.mapcount++;
	}
      }
    }
    cnt--;
  }
  if (VFSInfo.dirIterator==vfsIteratorStop) {
    // close directory
    VFSFileClose (VFSInfo.DIRref);
    VFSInfo.DIRref=0;
  }
  return;
}
// ------------------------------------
// computing rotated LCD dimensions
// recomputing map's variables after LCD rotating
// ------------------------------------
void CalcRotatedVars (void) {
  MemMove (&LCD.actual, &LCD.form, sizeof (LCD.actual));
  if (LCD.rotate==1 || LCD.rotate==3) {
    LCD.actual.native.width=LCD.form.native.height;
    LCD.actual.native.height=LCD.form.native.width;
    LCD.actual.standard.width=LCD.form.standard.height;
    LCD.actual.standard.height=LCD.form.standard.width;
  } 
  if((MapInfo.xRest=LCD.actual.native.width%MapInfo.MapHeader.Wx))
    MapInfo.xRest=MapInfo.MapHeader.Wx-MapInfo.xRest;
  if((MapInfo.yRest=LCD.actual.native.height%MapInfo.MapHeader.Wy))
    MapInfo.yRest=MapInfo.MapHeader.Wy-MapInfo.yRest;
  MapInfo.Xtiles=(LCD.actual.native.width+MapInfo.MapHeader.Wx-1)/MapInfo.MapHeader.Wx;
  MapInfo.Ytiles=(LCD.actual.native.height+MapInfo.MapHeader.Wy-1)/MapInfo.MapHeader.Wy;
  MapInfo.xOff=MapInfo.yOff=0;
  
//  MapInfo.incompleteX=(MapInfo.Xtiles*MapInfo.MapHeader.Wx!=LCD.actual.native.width);
//  MapInfo.incompleteY=(MapInfo.Ytiles*MapInfo.MapHeader.Wy!=LCD.actual.native.height);
}
// ------------------------------------
// opening map file
// ------------------------------------
void CheckStartXY (void) {
  if (MapInfo.curr_map.startX+MapInfo.Xtiles>MapInfo.MapHeader.Nx) MapInfo.curr_map.startX=MapInfo.MapHeader.Nx-MapInfo.Xtiles;
  if (MapInfo.curr_map.startX<0) MapInfo.curr_map.startX=0;
  if (MapInfo.curr_map.startY+MapInfo.Ytiles>MapInfo.MapHeader.Ny) MapInfo.curr_map.startY=MapInfo.MapHeader.Ny-MapInfo.Ytiles;
  if (MapInfo.curr_map.startY<0) MapInfo.curr_map.startY=0;
}
// ------------------------------------
// searching map in list
// ------------------------------------
Int16 SearchMap (Char *str) {
UInt16 i;
  for (i=0; i<VFSInfo.mapcount; i++)
    if (!StrCaselessCompare (VFSInfo.maplist[i]->name, str))
      return i;
  return -1;
}
// ------------------------------------
// rotate coordinates after tap to real coordinates
// ------------------------------------
void RotateTapCoords (UInt8 rotate, Int16 *x, Int16 *y) {
Int16 buf;

  if (MapInfo.MapHeader.Wx!=MapInfo.MapHeader.Wy) return;
  switch (rotate) {
    case 1:
      buf=*x;
      *x=*y;
      *y=LCD.form.standard.width-buf-1;
      break;      
    case 2:
      *x=LCD.form.standard.width-*x-1;
      *y=LCD.form.standard.height-*y-1;
      break;      
    case 3:
      buf=*y;
      *y=*x;
      *x=LCD.form.standard.height-buf-1;
      break;      
  }
}
// ------------------------------------
// init grid variables
// ------------------------------------
//void GridSetupInit (void) SECT_UI;
void GridSetupInit (void) {
double p2;

  Prefs.bin.distance=0.0;
  StrCopy (Prefs.str[gridunit], (MapInfo.gridX.pixels && MapInfo.gridX.measure && *MapInfo.gridX.unit)?MapInfo.gridX.unit:
                                (MapInfo.gridY.pixels && MapInfo.gridY.measure && *MapInfo.gridY.unit)?MapInfo.gridY.unit:"px");
  Prefs.bin.precision=MapInfo.gridX.measure/(double)MapInfo.gridX.pixels;
  p2=Prefs.bin.precision=1;
  if (MapInfo.gridX.pixels && MapInfo.gridX.measure) p2=Prefs.bin.precision=MapInfo.gridX.measure/(double)MapInfo.gridX.pixels;
  if (MapInfo.gridY.pixels && MapInfo.gridY.measure) p2=MapInfo.gridY.measure/(double)MapInfo.gridY.pixels;
  if (p2<Prefs.bin.precision) Prefs.bin.precision=p2;
}
// ------------------------------------
// redraw distance information on display
// ------------------------------------
void RedrawDistance (void) {
Char str[32];
UInt16 i;
  *str=0;
  if (selectPoint==point1 || selectPoint==point2) {
    i=StrDistance (str, Prefs.bin.distance);
  } else
  if (selectPoint==point_POI) {
    StrCopy (str, "tap to add POI");
  } else
  if (selectPoint==point_AzDi) {
    StrCopy (str, "tap start point");
  }
  i=StrLen (str);
  WinPaintChars (str, i, 0, 0);
}
// ------------------------------------
// show point on display
// ------------------------------------
void ShowPoint (Int16 x, Int16 y, UInt16 type) {
RGBColorType rgb;
Int16 buf;

  WinPushDrawState ();
  if (!type) {
    rgb.r=0xFF; rgb.g=0; rgb.b=0;
  } else {
    //rgb.r=0; rgb.g=0xFF; rgb.b=0;
    //rgb.r=0; rgb.g=0; rgb.b=0xFF;
    rgb.r=0; rgb.g=0; rgb.b=0;
  }
  WinSetForeColorRGB (&rgb, NULL);
  WinSetDrawMode (winPaint);
  // coords rotate
  switch (LCD.rotate) {
    case 1:
      buf=y;
      y=x;
      x=LCD.form.standard.width-buf-1;
      break;      
    case 2:
      x=LCD.form.standard.width-x-1;
      y=LCD.form.standard.height-y-1;
      break;      
    case 3:
      buf=x;
      x=y;
      y=LCD.form.standard.height-buf-1;
      break;      
  }  
  // drawing point
  WinPaintLine (x-1, y-1, x, y-1);
  WinPaintLine (x+1, y-1, x+1, y);
  WinPaintLine (x+1, y+1, x, y+1);
  WinPaintLine (x-1, y+1, x-1, y);
  WinPopDrawState ();
}
// ------------------------------------
// draw distance "window" region
// ------------------------------------
void DistanceWindow (Boolean save) {
RectangleType rect;
UInt16 err;
Int32 x, y;

  if (save) {
    if (win_dist!=NULL) {
      //MemHandleFree (win_dist);
      WinDeleteWindow (win_dist, false);
      win_dist=NULL;
    }
    rect.topLeft.x=rect.topLeft.y=0;
    // save whole row
    rect.extent.x=LCD.form.standard.width;
    rect.extent.y=16;
    win_dist=WinSaveBits (&rect, &err);
    RedrawDistance ();
    // if tha map is same as cood map, show last point selected
    if (selectPoint==point2) {
      if (!StrCaselessCompare (MapInfo.curr_map.name, Prefs.str[coordmap])) {
        x=Prefs.bin.coord2X-MapInfo.curr_map.startX*MapInfo.MapHeader.Wx;
        y=Prefs.bin.coord2Y-MapInfo.curr_map.startY*MapInfo.MapHeader.Wy;
        if (x>=0 && x<LCD.form.native.width-1 && y>=0 && y<LCD.form.native.height-1) {
          ShowPoint ((x*kDensityLow)/LCD.density, (y*kDensityLow)/LCD.density, 0);
        }
      }
    }
  } else {
    WinRestoreBits (win_dist, 0, 0);
    win_dist=NULL;
  }
}
/***
// ------------------------------------
// skip float value in string
// ------------------------------------
UInt16 SkipFloat (Char *str) {
UInt16 idx=0;
  if (str[idx]=='-' || str[idx]=='+') idx++;
  while (str[idx]>='0' && str[idx]<='9') idx++;
  if (str[idx]=='.' || str[idx]==',') idx++;
  if (str[idx]=='e' || str[idx]=='E') idx++;
  if (str[idx]=='-' || str[idx]=='+') idx++;
  while (str[idx]>='0' && str[idx]<='9') idx++;
  return idx;
}
***/
// ------------------------------------
// look for zoom map if available
// ------------------------------------
Int16 LoadZoom (Int16 step, Int16 x, Int16 y) {
  // compute relative position coordinates for zooming
  MapInfo.rel_pos_x=MapInfo.curr_map.startX*MapInfo.MapHeader.Wx+(x*LCD.density)/kDensityLow;
  MapInfo.rel_pos_y=MapInfo.curr_map.startY*MapInfo.MapHeader.Wy+(y*LCD.density)/kDensityLow;
  MapInfo.rel_pos_x/=MapInfo.MapHeader.max_x-MapInfo.MapHeader.min_x;
  MapInfo.rel_pos_y/=MapInfo.MapHeader.max_y-MapInfo.MapHeader.min_y;
  // test if requested zoom is available
  if (TestFile (step)) return 1;
  // load requested zoom
  if (Prefs.bin.flags&CartoonMode || MapInfo.MapHeader.version&CartoonFile) {
    MapInfo.rel_pos_x=0;
    MapInfo.rel_pos_y=0;
  }
  if (LoadMapFile (posSetRel)) return 2;
  ShowBitmaps (0, 0, MapInfo.curr_map.startX, MapInfo.curr_map.startY, MapInfo.Xtiles, MapInfo.Ytiles);
  if (selectPoint!=pointNone) DistanceWindow (true);
  return 0;
}
// ------------------------------------
// rotate ??? right
// ------------------------------------
void RotateDirRight (Int16 *dir) {
Int16 cnt;
  if (!LCD.rotate) return;
  cnt=LCD.rotate;
  while (cnt) {
    *dir>>=1;
    if (*dir&0x08) {*dir|=0x80; *dir&=0xF0;}
    cnt--;
  }
}
// ------------------------------------
// rotate ??? left
// ------------------------------------
void RotateDirLeft (Int16 *dir) {
Int16 cnt;
  if (!LCD.rotate) return;
  cnt=LCD.rotate;
  while (cnt) {
    *dir<<=1;
    if (*dir&0x100) {*dir|=0x10; *dir&=0xF0;}
    cnt--;
  }
}
// ------------------------------------
// return compression type string
// ------------------------------------
Char *ComprType (UInt16 type) {

  if (type&0x80) {
    switch (type) {
    case 0x80: return "ZIP";
    case 0x81: return "LZO";
    default: return "unknown";
    }
  }
  return "none";
}
// ------------------------------------
// update scrollbar for multiline scrollable field
// ------------------------------------
void UpdateScrollbar (FormPtr frm, UInt16 field, UInt16 scroll) {
UInt16 currPos, txtHeight, fldHeight, maxValue;

  FldGetScrollValues (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, field)), &currPos, &txtHeight, &fldHeight);
  if (txtHeight>fldHeight) maxValue=txtHeight-fldHeight;
  else
  if (currPos) maxValue=currPos;
  else maxValue=0;
  SclSetScrollBar (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, scroll)), currPos, 0, maxValue, fldHeight-1);
}
// ------------------------------------
// scroll lines in multiline scrollable field
// ------------------------------------
void ScrollLines (FormPtr frm, UInt16 field, UInt16 scroll, int numLines, Boolean redraw) {
FieldPtr fld;

  fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, field));
  if (numLines<0)
    FldScrollField (fld, -numLines, winUp);
  else
    FldScrollField (fld, numLines, winDown);
  if (FldGetNumberOfBlankLines (fld) && (numLines<0 || redraw))
    UpdateScrollbar (frm, field, scroll);
}
// ------------------------------------
// Information Form handler
// ------------------------------------
Boolean InfoFormHandler (EventPtr event) {
FormPtr         frm;
Boolean         handled;

  frm = FrmGetActiveForm ();
  handled=false;
  switch (event->eType) {
    case keyDownEvent:
      switch (event->data.keyDown.chr) {
        case vchrPageUp:
          ScrollLines (frm, map_info, info_scroll, -10, true);
          UpdateScrollbar (frm, map_info, info_scroll);
          break;
        case vchrPageDown:
          ScrollLines (frm, map_info, info_scroll, 10, true);
          UpdateScrollbar (frm, map_info, info_scroll);
          break;
      }
      break;
    case sclRepeatEvent:
      ScrollLines (frm, map_info, info_scroll, event->data.sclRepeat.newValue - event->data.sclRepeat.value, false);
      break;
    default:
      break;
  }
  return handled;
}
// ------------------------------------
// enables form for HiRes+ display
// ------------------------------------
void SetHiResPlusWindow (FormPtr frm) {
  WinSetConstraintsSize (FrmGetWindowHandle (frm), 160, 160, LCD.device.standard.width, 160, 160, LCD.device.standard.height);
  FrmSetDIAPolicyAttr (frm, frmDIAPolicyCustom);
  PINSetInputAreaState (pinInputAreaUser); //Closed);
  StatShow ();
}
// ------------------------------------
// resizes form window for HiRes+ display
// ------------------------------------
void ResizeFormWindow (FormPtr frm) {
RectangleType   rect;
WinHandle       hwin;

  // obtaining previous form size
  WinGetBounds (hwin=FrmGetWindowHandle (frm), &rect);
  // calculating new form size
  if (rect.extent.x<=160) rect.extent.x+=LCD.form.standard.width-160;
  if (rect.extent.y<=160) rect.extent.y+=LCD.form.standard.height-160;
  // hide DIA, let control bar, disable DIA trigger
  WinSetBounds (hwin, &rect);
}
// ------------------------------------
// resizes form objects for HiRes+ display
// ------------------------------------
void ResizeFormObjects (FormPtr frm, UInt16 dx, UInt16 dy) {
UInt16          objects, i;
Coord           x, y;
RectangleType   rect;

  // recalculating all form's objects
  objects=FrmGetNumberOfObjects (frm);
  for (i=0; i<objects; i++) {
    switch (FrmGetObjectType (frm, i)) {
      case frmControlObj:
        FrmGetObjectPosition (frm, i, &x, &y);
        FrmSetObjectPosition (frm, i, x+dx, y+dy);
        break;
      case frmFieldObj:
        FrmGetObjectBounds (frm, i, &rect);
        rect.extent.x+=dx;
        rect.extent.y+=dy;
        FrmSetObjectBounds (frm, i, &rect);
        break;
      case frmScrollBarObj:
        FrmGetObjectPosition (frm, i, &x, &y);
        FrmSetObjectPosition (frm, i, x+dx, y);
        FrmGetObjectBounds (frm, i, &rect);
        rect.extent.y+=dy;
        FrmSetObjectBounds (frm, i, &rect);
        break;
      default:
        break;
    }
  }
}
// ------------------------------------
// show Information Form
// ------------------------------------
void ShowInfoWindow (Char *title, Char *text) {
FormPtr		difrm;
FieldPtr	fld;

  MenuEraseStatus (NULL);
  // opening info window
  difrm=FrmInitForm (info_form);
  FrmSetTitle (difrm, title);
  if (LCD.resize && (LCD.form.standard.width>160 || LCD.form.standard.height>160)) {
    // enabling HiResPlus window (w/o graffiti area)
    SetHiResPlusWindow (difrm);
    // resizing window itself
    ResizeFormWindow (difrm);
    // resizing/repositioning form objects
    ResizeFormObjects (difrm, LCD.form.standard.width-160, LCD.form.standard.height-160);
  }
  FldSetTextPtr (fld=FrmGetObjectPtr (difrm, FrmGetObjectIndex (difrm, map_info)), text);
  FldRecalculateField (fld, false);
  UpdateScrollbar (difrm, map_info, info_scroll);
  FrmDrawForm (difrm);
  FrmSetEventHandler (difrm, (FormEventHandlerPtr) InfoFormHandler);
  FrmDoDialog (difrm);
  FrmDeleteForm (difrm);
}  
// ------------------------------------
// show information about actual map
// ------------------------------------
void MapInfoAlert (void) {
Char		info[512], *iptr;

  *info=0;
  iptr=info;  

//  iptr+=StrPrintF (iptr, "VolRefNum: %04x\n", MapInfo.curr_map.volRefNum);
//  WinGetBounds (FrmGetWindowHandle (FrmGetActiveForm ()), &rect);
//  iptr+=StrPrintF (iptr, "Win: [%d,%d]+[%d,%d]\n", rect.topLeft.x, rect.topLeft.y, rect.extent.x, rect.extent.y);
//  WinGetClip (&rect);
//  iptr+=StrPrintF (iptr, "Clip: [%d,%d]+[%d,%d]\n", rect.topLeft.x, rect.topLeft.y, rect.extent.x, rect.extent.y);

  if (MapInfo.valid) {
    iptr+=StrPrintF (iptr, "Name: %s\nSize: %ldx%ld\nTiles: %ldx%ld\nTile size: %dx%d",
        MapInfo.curr_map.name, MapInfo.MapHeader.size_x, MapInfo.MapHeader.size_y, MapInfo.MapHeader.Nx, MapInfo.MapHeader.Ny, MapInfo.MapHeader.Wx, MapInfo.MapHeader.Wy);
    if (MapInfo.gridX.pixels && MapInfo.gridX.pixels==MapInfo.gridY.pixels && MapInfo.gridX.measure==MapInfo.gridY.measure && !StrCaselessCompare (MapInfo.gridX.unit, MapInfo.gridY.unit)) {
      iptr+=StrPrintF (iptr, "\nGrid X/Y: %ldpx=%ld%s", MapInfo.gridX.pixels, MapInfo.gridX.measure, MapInfo.gridX.unit);
    } else {
      if (MapInfo.gridX.pixels)
        iptr+=StrPrintF (iptr, "\nGrid X: %ldpx=%ld%s", MapInfo.gridX.pixels, MapInfo.gridX.measure, MapInfo.gridX.unit);
      if (MapInfo.gridY.pixels)
        iptr+=StrPrintF (iptr, "\nGrid Y: %ldpx=%ld%s", MapInfo.gridY.pixels, MapInfo.gridY.measure, MapInfo.gridY.unit);
    }
    iptr+=StrPrintF (iptr, "\nDrawing time: %ld ticks\nCompression type: %s\nCompression ratio: %ld%%",
        MapInfo.speed_index, ComprType (MapInfo.MapHeader.version&CompressedMask), (MapInfo.ratio2)?(MapInfo.ratio1*100)/MapInfo.ratio2:0);
    if (MapInfo.GPScal && MapInfo.GPScount)
      iptr+=StrPrintF (iptr, "\nGPS calibration: %d points", MapInfo.GPScount);
  }
  iptr+=StrPrintF (iptr, "\n\nLCD: %ldx%ld, %ldbpp", LCD.actual.native.width, LCD.actual.native.height, LCD.bits);
  iptr+=StrPrintF (iptr, "\nLCD tiles: %dx%d", MapInfo.Xtiles, MapInfo.Ytiles);
  if (LCD.translate!=0x10)
    iptr+=StrPrintF (iptr, "\nPalette: %s", LCD.systemPalette?"PalmOS":"user");
  ShowInfoWindow ("Map Info", info);
}
/***
// ------------------------------------
// quick integer square-root
// ------------------------------------
UInt32 SQRT (UInt32 val) {
UInt32 rval, tx;
  // guess result
  rval=1; tx=val;
  while (tx>1) {rval<<=1; tx>>=2;}
  // newton iteMapInfo.ration
  //tx=rval;
  do {
    tx=rval;
    rval=(1+rval+(val+rval/2)/rval)/2;
  } while (tx!=rval);
  return rval;
}
***/
// ------------------------------------
// builds distance string from float value
// ------------------------------------
UInt16 StrDistance (Char *str, double val) {
UInt16 idx;
double precision;

  precision=Prefs.bin.precision;
  if (precision<=0) precision=1.0;
  idx=0;
  if (val<0) {str[idx++]='-'; val=-val;}
  idx+=StrPrintF (&str[idx], "%ld", (UInt32)val);
  if (precision<1.0) {
    val-=(UInt32)val;
    str[idx++]='.';
    while (precision<1.0) {
      precision*=10;
      val*=10;
      str[idx]=val;
      val-=str[idx];
      str[idx++]+='0';
    }
  }
  idx+=StrPrintF (&str[idx], "%s", (*Prefs.str[gridunit])?Prefs.str[gridunit]:"px");
  return idx;
}
// ------------------------------------
// quick float square-root
// ------------------------------------
#define sqrt_error      0.01
#define sqrt_rerr       0.0001
double sqrt_d (double val) {
double rval, tx, err;

  if (val<=0.0) return 0.0;
  // guess result
  rval=1.0; tx=val;
  if (val>1.0)
    while (tx>1.0) {rval*=2.0; tx/=4.0;}
  else
    while (tx<1.0) {rval/=2.0; tx*=4.0;}
  err=rval*sqrt_rerr;
  // newton iteMapInfo.ration
  //tx=rval;
  do {
    tx=rval;
    rval=(rval+val/rval)/2.0;
    tx-=rval;
    if (tx<0) tx=-tx;
  } while (tx>err); //sqrt_error);
  return rval;
}
// ------------------------------------
// compute distance
// ------------------------------------
double ComputeDistance (Int32 x1, Int32 y1, Int32 x2, Int32 y2) {
double xd1,yd1;

  xd1=x1-x2;
  yd1=y1-y2;
  if (MapInfo.gridX.pixels && MapInfo.gridX.measure)
    xd1*=MapInfo.gridX.measure; xd1/=MapInfo.gridX.pixels;
  if (MapInfo.gridY.pixels && MapInfo.gridY.measure)
    yd1*=MapInfo.gridY.measure; yd1/=MapInfo.gridY.pixels;
  return sqrt_d ((xd1*xd1)+(yd1*yd1));
}  
// ------------------------------------
// show last distance in Information Form
// ------------------------------------
void ShowDistances (void) {
Char msg[256];
Int16 i, flg;
  i=flg=0;
  if (!StrCaselessCompare (Prefs.str[coordmap], MapInfo.curr_map.name)) flg|=1;
  // if the map on screen isn't the same as for coordinations, show the map filename
  if (!(flg&1)) {
    //if (i) msg[i++]='\n';
    i+=StrPrintF (&msg[i], "Map: %s", Prefs.str[coordmap]);
  }
  // path  (point-by-point) distance
  if (i) msg[i++]='\n';
  i+=StrPrintF (&msg[i], "Total distance: ");
  i+=StrDistance (&msg[i], Prefs.bin.distance);
  // if the map is the same as coord map, show direct distances
  if (flg&1) {
    if (i) msg[i++]='\n';
    i+=StrPrintF (&msg[i], "Direct distance: ");
    i+=StrDistance (&msg[i], ComputeDistance (Prefs.bin.coord1X, Prefs.bin.coord1Y, Prefs.bin.coord2X, Prefs.bin.coord2Y));
    // show point coorinates for debug purposes  
    if (i) msg[i++]='\n';
    i+=StrPrintF (&msg[i], "Point1=[%ld,%ld]\nPoint2=[%ld,%ld]", Prefs.bin.coord1X, Prefs.bin.coord1Y, Prefs.bin.coord2X, Prefs.bin.coord2Y);
    // show GPS coordinates for debug purposes



  }

  msg[i]=0;
  ShowInfoWindow ("Distances", msg);
}
// ------------------------------------
// save actual map/position into history database
// ------------------------------------
void SaveHistory (void) {
UInt16 i;
MemHandle dataHndl;

  if (!DmNumRecords (histDB)) {
    i=0;
    dataHndl=DmNewRecord (histDB, &i, sizeof (MapInfo.curr_map));
  } else {
    dataHndl=DmGetRecord (histDB, 0);
  }
  if (dataHndl) {
    DmWrite (MemHandleLock (dataHndl), 0, &MapInfo.curr_map, sizeof (MapInfo.curr_map));
    MemHandleUnlock (dataHndl);
    DmReleaseRecord (histDB, 0, true);
  }
}
// ------------------------------------
// clean-up history database
// ------------------------------------
void CleanUpHistory (void) {
UInt16 i, j;
historyType *recmap;
  // removing invalig filenames
  if (VFSInfo.maplist!=NULL) {
    while (!VFSInfo.DirectoryOK) GetDirEntry (-1);
    for (i=DmNumRecords (histDB); i; ) {
      i--;
      // looking in VFSInfo.maplist for name
      recmap=MemHandleLock (DmQueryRecord (histDB, i));
      for (j=0; j<VFSInfo.mapcount; j++) {
        if (!StrCaselessCompare (recmap->name, VFSInfo.maplist[j]->name))
          break;
      }
      MemPtrUnlock (recmap);
      if (j>=VFSInfo.mapcount) {
        DmRemoveRecord (histDB, i);
      }
    }
  }
  // removing all history entries over maximum allowed count
  i=DmNumRecords (histDB);
  while (i>MaxHistoryEntries) {
    i--;
    DmRemoveRecord (histDB, i);
  }
}
// ------------------------------------
// insert history record at beginning
// ------------------------------------
void InsertHistory (void) {
UInt16 i;
MemHandle dataHndl;

  i=0;
  dataHndl=DmNewRecord (histDB, &i, sizeof (MapInfo.curr_map));
  if (dataHndl) {
    // I don't need to save history here - it is done on opening new map or on application exit
    // but it is more safe to do it now...
    DmWrite (MemHandleLock (dataHndl), 0, &MapInfo.curr_map, sizeof (MapInfo.curr_map));
    MemHandleUnlock (dataHndl);
    DmReleaseRecord (histDB, 0, true);
    if (i) {
      DmMoveRecord (histDB, i, 0);
    }
  }
  CleanUpHistory ();
}
// ------------------------------------
// add user event to event queue
// ------------------------------------
void UserEvent (eventsEnum eType) {
EventType       usrEvent;
  usrEvent.eType=eType;
  EvtAddEventToQueue (&usrEvent);
}
// ------------------------------------
// convert user button to user event
// ------------------------------------
Boolean UserButton (UInt16 key) {
  if (key>btn_count) return false;
  if (!Prefs.bin.buttons[key] || Prefs.bin.buttons[key]>(mapMaxKeyEvent-firstUserEvent+1)) return false;
  UserEvent (Prefs.bin.buttons[key]+firstUserEvent-1);
  // key click - for all keys except Select
  if (key!=btn5waySelect)
    SndPlaySystemSound (sndClick);
  return true;
}
// ------------------------------------
// general key handling function
// ------------------------------------
Boolean HandleKeys (EventPtr event) {
UInt16 i, i2;
UInt16 delay, period, ddelay, t, ts;
Boolean qahead;
WChar newchar[8]={
  0, //vchrRockerUp, 
  0, //vchrRockerDown,
  vchrRockerLeft,
  vchrRockerRight,
  0, //vchrRockerCenter,
  0,
  0,
  0
};
EventType newevent;

  // basic check
  if (event->eType!=keyDownEvent) // && event->eType!=keyUpEvent) 
    return false;

  // special support for T|E's SELECT button
  if (event->data.keyDown.chr==vchrNavChange) {
    switch (event->data.keyDown.keyCode & (navChangeSelect | navBitSelect)) {
      case navChangeSelect | navBitSelect: // first press
        keypresscnt[btn5waySelect/2]=0;
        return false;
      case navBitSelect: // autorepeat
        if (keypresscnt[btn5waySelect/2]) 
          // it seems that PalmOS needs more (10?) Select-key's autorepeat events...
          return Prefs.bin.buttons[btn5waySelectLong]!=0;
        keypresscnt[btn5waySelect/2]=1;
        return UserButton (btn5waySelectLong);
      case navChangeSelect: // release
        return (keypresscnt[btn5waySelect/2])?true:UserButton (btn5waySelect);
    }
    // event translation from T|E's Left/Right to Rocker keys
    // it takes first key only!!!
    // to be more strict - this function should add new events for every key combination...
    newevent.eType=keyDownEvent;
    newevent.data.keyDown.keyCode=0;
    newevent.data.keyDown.chr=0;
    for (i=0; i<8; i++) {
      if (!newchar[i]) continue;
      newevent.data.keyDown.modifiers=commandKeyMask;
      switch ((event->data.keyDown.keyCode>>i)&(navChangeUp | navBitUp)) {
        case navBitUp:
          // repeated keypress
          newevent.data.keyDown.modifiers|=autoRepeatKeyMask;
        case navChangeUp | navBitUp:
          // first keypress
          newevent.data.keyDown.chr=newchar[i];
          EvtAddEventToQueue (&newevent);
          break;
  //      case navChangeUp:
  //        break;
  //      case 0x0000:
  //        break;
      }
    }
    // if new event generated, return true
    return newevent.data.keyDown.chr!=0;
  }

  // special support for T5's SELECT button
  if (event->data.keyDown.chr==vchrRockerCenter)
    return UserButton (btn5waySelect);
  if (event->data.keyDown.chr==vchrAttnIndicatorTapped)
    return UserButton (btn5waySelectLong);

  // looking if key is supported
  for (i=0; i<btn_count; i++)
    if (event->data.keyDown.chr==known_buttons[i])
      break;
  if (i>=btn_count) 
    return false;
  i2=i*2;
//  if (event->eType==keyDownEvent) {
    if (!Prefs.bin.buttons[i2+1])
      // long keypress function not set
      return UserButton (i2);
    // long keypress function required
    if (event->data.keyDown.modifiers&autoRepeatKeyMask) {
      // aurorepeated event
      if (keypresscnt[i]) 
        return true;
      // calling selected action
      keypresscnt[i]=1;
      return UserButton (i2+1);
    }
    // first keypress event
    keypresscnt[i]=0;
    // waiting if keypress will be long enough to generate autorepeat
    KeyRates (false, &delay, &period, &ddelay, &qahead);
    ts=delay/5;
    for (t=0; t<delay; t+=ts) {
      SysTaskDelay (ts);
      if (!KeyCurrentState ()) 
        return UserButton (i2);
    }
    // long press detected; I hope system will generate autoRepeat-ed keyDownEvent
    return true;
//  }
/**
  if (event->eType==keyUpEvent) {
    if (!Prefs.bin.buttons[i2+1])
      return false;
    // long keypress function required
    if (keypresscnt[i])
      return true;
    if (Prefs.bin.buttons[i2])
      return UserButton (i2);
    // if short key press action isn't set - change event to keyDown and send it to the system
    event->eType=keyDownEvent;
    event->data.keyDown.modifiers=0;//commandKeyMask;
    //return false;
  }
**/
  return false;
}
// ------------------------------------
// add pen tap to pen queue
// ------------------------------------
void TapPoint (Int16 x, Int16 y) {
PointType point;
  point.x=(x*(Int32)LCD.density)/kDensityLow; point.y=(y*(Int32)LCD.density)/kDensityLow;
  PenScreenToRaw (&point);
  EvtEnqueuePenPoint (&point);
  point.x=point.y=-1;
  EvtEnqueuePenPoint (&point);
}
// ------------------------------------
// main form handler
// ------------------------------------
static Boolean ViewMapFormHandler (EventPtr event) {
FormPtr         frm, dfrm;
Boolean         handled;
ListPtr         lst;
Int16           i, j;
Int16           dir;
RectangleType   rect;
Char            **hlist;
UInt16          hcnt;
historyType     *hptr;
UInt32          px, py;
MemHandle       hndl;
POItype         *pptr;
//const UInt16    DirRotate[7]={dirLeft, dirDown, dirRight, dirUp, dirLeft, dirDown, dirRight};
GPSinfoType     GPSpos;
Char            *str, fls[80];
double          azimuth, distance;

  frm = FrmGetActiveForm ();
  handled=false;
  switch (event->eType) {
    case frmOpenEvent:
      if (LCD.resize) {
        SetHiResPlusWindow (frm);
      }
    case frmUpdateEvent:
      FrmDrawForm (frm);
      AttnIndicatorEnable (false);
      // if setup changed color conversion mode, set default palette and reload bitmap
      if ((Prefs.bin.flags^oldflags)&ColMask) {
        WinPalette (winPaletteSetToDefault, 0, 0, NULL);
        LCD.systemPalette=true;
	LoadMapFile (posCheck);
	oldflags=Prefs.bin.flags;
      }
      LCD.rotate=(Prefs.bin.flags&RotMask)>>RotBits;
      selectPoint=pointNone;
      // draw bitmaps
      WinGetBounds (WinGetDisplayWindow (), &rect);
      LCD.form.native.width=((LCD.form.standard.width=rect.extent.x)*LCD.density)/kDensityLow;
      LCD.form.native.height=((LCD.form.standard.height=rect.extent.y)*LCD.density)/kDensityLow;
      WinSetBounds (FrmGetWindowHandle (frm), &rect);
      CalcRotatedVars ();
      ShowBitmaps (0, 0, MapInfo.curr_map.startX, MapInfo.curr_map.startY, MapInfo.Xtiles, MapInfo.Ytiles);
      handled=true;
      break;
    case winDisplayChangedEvent:
      WinGetBounds (WinGetDisplayWindow (), &rect);
      if (rect.extent.x!=LCD.form.standard.width || rect.extent.y!=LCD.form.standard.height) {
        LCD.form.native.width=((LCD.form.standard.width=rect.extent.x)*LCD.density)/kDensityLow;
        LCD.form.native.height=((LCD.form.standard.height=rect.extent.y)*LCD.density)/kDensityLow;
        WinSetBounds (FrmGetWindowHandle (frm), &rect);
        CalcRotatedVars ();
        ShowBitmaps (0, 0, MapInfo.curr_map.startX, MapInfo.curr_map.startY, MapInfo.Xtiles, MapInfo.Ytiles);
      }
      handled=true;
      break;
    case menuCmdBarOpenEvent:
      for (i=0; cmdbaricons[i].action; i++) {
        if (Prefs.bin.cmd_icons&(1<<i))
          MenuCmdBarAddButton (menuCmdBarOnLeft, cmdbaricons[i].bitmap, menuCmdBarResultMenuItem, cmdbaricons[i].action, NULL);
      }
      break;
    case winExitEvent: // tracking of menu and other windows creation
      if (event->data.winExit.exitWindow==(WinHandle)FrmGetFormPtr (view_form)) hardEnable=0;
      break;
    case winEnterEvent: // tracking of menu and other windows creation
      if (event->data.winEnter.enterWindow==(WinHandle)FrmGetFormPtr (view_form) && event->data.winEnter.enterWindow==(WinHandle)FrmGetFirstForm ()) hardEnable=true;
      break;
    case menuEvent:
      handled=true;
      switch (event->data.menu.itemID) {
        // MAP
	case menu_openmap:
	  UserEvent (mapOpen);
	  break;
	case menu_top:
	  UserEvent (mapTop);
	  break;
        case menu_zoomin:
          UserEvent (mapZoomIn);
          break;
        case menu_zoomout:
          UserEvent (mapZoomOut);
          break;
        case menu_center:
          UserEvent (mapCenter);
          break;
        case menu_history:
          UserEvent (mapHistory);
          break;
        case menu_info:
          UserEvent (mapInfo);
          break;
        // GO TO
        case menu_overview:
          UserEvent (mapOverview);
          break;
        case menu_POI:
          UserEvent (mapPOI);
          break;
        case menu_all_POIs:
          // projdu celou databazi POI a filtruju podle nazvu mapy
          if (!POI_DB) break;
          if (!(hcnt=DmNumRecords (POI_DB))) break;
          px=MapInfo.curr_map.startX*MapInfo.MapHeader.Wx;
          py=MapInfo.curr_map.startY*MapInfo.MapHeader.Wy;
          for (i=0; i<hcnt; i++) {
            pptr=MemHandleLock(DmQueryRecord (POI_DB, i));
            if (!StrCompare (pptr->fileinfo.name, MapInfo.curr_map.name)) {
              if (pptr->fileinfo.startX>=px && pptr->fileinfo.startX<px+LCD.actual.native.width && pptr->fileinfo.startY>=py && pptr->fileinfo.startY<py+LCD.actual.native.height)
                ShowPoint (((pptr->fileinfo.startX-px)*kDensityLow)/LCD.density, ((pptr->fileinfo.startY-py)*kDensityLow)/LCD.density, 1);
            }
            MemPtrUnlock (pptr);
          }
          break;
        //case menu_gotoLast:
          //break;
        case menu_azimuth:
          // select point and enter azimuth and distance
          if (selectPoint!=pointNone) DistanceWindow (false);
          selectPoint=point_AzDi;
          DistanceWindow (true);
          break;
        case menu_gotoGPS:
          // zadani GPS
/**/
          // zatim pouziju addPOI_form
          dfrm=FrmInitForm (addPOI_form);
          i=FrmDoDialog (dfrm);
          hndl=FldGetTextHandle (FrmGetObjectPtr (dfrm, FrmGetObjectIndex (dfrm, POI_name)));
          if (hndl) {
            // parsovani zadanych souradnic
            str=MemHandleLock (hndl);
            str+=SkipSpaces (str);
/**
            str="50.75 15.10";
            str="50.74555 15.09038333" // poklad Arktida ve Vratislavicich
**/
            str+=GetFloat (str, &GPSpos.lat.d);
            while (*str && (*str<=' ' || *str==',')) str++;
            GetFloat (str, &GPSpos.lon.d);
/**/
            MemHandleUnlock (hndl);
          }            
          FrmDeleteForm (dfrm);
/**/
          // prepocet na XY
          GPS2XY (&GPSpos);
          // zobrazeni vysledku
          FlpFToA (GPSpos.lat.fd, fls);
          StrCat (fls, ", ");
          FlpFToA (GPSpos.lon.fd, &fls[StrLen (fls)]);
          StrCat (fls, " = ");
          FlpFToA (GPSpos.x.fd, &fls[StrLen (fls)]);
          StrCat (fls, ", ");
          FlpFToA (GPSpos.y.fd, &fls[StrLen (fls)]);
          DEBUG (fls);
          if (GPSpos.x.d>=0 && GPSpos.x.d<=1 && GPSpos.y.d>=0 && GPSpos.y.d<=1) {
            // poloha bodu
            px=MapInfo.MapHeader.size_x*GPSpos.x.d;
            py=MapInfo.MapHeader.size_y*GPSpos.y.d;
            // poloha mapy
            MapInfo.curr_map.startX=px/MapInfo.MapHeader.Wx-MapInfo.Xtiles/2;
            MapInfo.curr_map.startY=py/MapInfo.MapHeader.Wy-MapInfo.Ytiles/2;
            if (MapInfo.curr_map.startX<0) MapInfo.curr_map.startX=0;
            if (MapInfo.curr_map.startY<0) MapInfo.curr_map.startY=0;
            ShowBitmaps (0, 0, MapInfo.curr_map.startX, MapInfo.curr_map.startY, MapInfo.Xtiles, MapInfo.Ytiles);
            // zobrazeni bodu
            ShowPoint (((px-MapInfo.curr_map.startX*MapInfo.MapHeader.Wx)*kDensityLow)/LCD.density, ((py-MapInfo.curr_map.startY*MapInfo.MapHeader.Wy)*kDensityLow)/LCD.density, 0);
          }
          break;
        // SERVICES
        case menu_add_POI:
          // default POI's position
          POI.fileinfo.startX=(MapInfo.curr_map.startX+MapInfo.Xtiles/2)*MapInfo.MapHeader.Wx;
          POI.fileinfo.startY=(MapInfo.curr_map.startY+MapInfo.Ytiles/2)*MapInfo.MapHeader.Wy;
          POI.fileinfo.volRefNum=MapInfo.curr_map.volRefNum;
          StrCopy (POI.fileinfo.name, MapInfo.curr_map.name);
          *POI.name=0;
          if (selectPoint!=pointNone) DistanceWindow (false);
          selectPoint=point_POI;
          DistanceWindow (true);
          break;
        case menu_del_POI:
          handled=true;
          // make list of all POIs
          if (!POI_DB) break;
          if (!(hcnt=DmNumRecords (POI_DB))) break;
          hlist=MemPtrNew (hcnt*sizeof (Char*));
          if (hlist==NULL) break;
#ifdef CopyNames
          hlist[0]=MemPtrNew (hcnt*256);
#endif
          // loading POI names
          //it is not needed to make new space - fill pointers only!
          // and change it while showing history too ???
          for (i=0; i<hcnt; i++) {
            pptr=MemHandleLock(DmQueryRecord (POI_DB, i));
#ifdef CopyNames
            if (i) hlist[i]=&hlist[i-1][256];
            MemMove (hlist[i], pptr->name, 256);
#else
            hlist[i]=pptr->name;
#endif
            MemPtrUnlock (pptr);
          }
          // show list
          LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_hist)), hlist, hcnt);
          LstSetSelection (lst, 0);
          j=LstPopupList (lst);
          // free memory
#ifdef CopyNames
          MemPtrFree (hlist[0]);
#endif
          MemPtrFree (hlist);
          // if item selected
          if (j==-1) break;
          // ensure that user wants to delete selected POI
          if (FrmAlert (deletePOIquest)) break;
          // delete selected POI
          DmRemoveRecord (POI_DB, j);
          break;
        case menu_setroute:
          UserEvent (mapSetPoint1);
          break;
        case menu_addroute:
          UserEvent (mapAddPoint2);
          break;  
        case menu_distances:
          UserEvent (mapDistances);
          break;
        case menu_setoverview:
          StrCopy (Prefs.str[overviewmap], MapInfo.curr_map.name);
          break;
        // VIEWER
        case menu_setup:
          FrmGotoForm (setup_form);
          break;
        case menu_grid:
          UserEvent (mapGrid);
          break;
	case menu_about:
	  if(FrmCustomAlert(frm_about,build,build_date,build_time))
	    FrmHelp (str_about);
	  break;
	case menu_rotateL:
	  UserEvent (mapRotateL);
	  break;
	case menu_rotateR:
	  UserEvent (mapRotateR);
	  break;
	case menu_help:
	  FrmHelp (viewer_help);
	  break;
	default:
	  handled=false;
	  break;
      }
      break;
//    case keyUpEvent:
//      handled=HandleKeys (event);
//      break;
    case keyDownEvent:
      // handle user-selected keys
      handled=HandleKeys (event);
      if (handled) break;
      // handle other keys
      switch (event->data.keyDown.chr) {
        case ' ':
          UserEvent (mapZoomIn);
          handled=true;
          break;
        case '\x08':
          UserEvent (mapZoomOut);
          handled=true;
          break;
/***
        case 't': // top map - map (.bmd) with smallest number
          UserEvent (mapTop);
          handled=true;
          break;
        case 'o':
          UserEvent (mapOverview);
          handled=true;
          break;
        case 'p':
          UserEvent (mapPlan);
          handled=true;
          break;
        case 'h':
          UserEvent (mapHome);
          handled=true;
          break;
***/
	default:
	  break;
      }
      break;
/*
    case ctlSelectEvent:
      switch (event->data.ctlSelect.controlID) {
	default:
	  break;
      }
      break;
*/
    case penDownEvent:
      // checking if tap is inside LCD
      if (event->screenX<0 || event->screenX>=LCD.form.standard.width || event->screenY<0 || event->screenY>=LCD.form.standard.height)
        break;
      // rotating coords
      if (LCD.rotate)
        RotateTapCoords (LCD.rotate, &event->screenX, &event->screenY);
      // if slecting points, do not move map by tapping
      if (selectPoint==pointNone) {
        // normal action
        dir=0;
        if (event->screenX<40 && MapInfo.curr_map.startX)
          dir|=dirLeft;
        else
        if (event->screenX>=(LCD.actual.standard.width-40) && (MapInfo.curr_map.startX+MapInfo.Xtiles)<MapInfo.MapHeader.Nx)
          dir|=dirRight;
        if (event->screenY<40 && MapInfo.curr_map.startY)
          dir|=dirUp;
        else
        if (event->screenY>=(LCD.actual.standard.height-40) && (MapInfo.curr_map.startY+MapInfo.Ytiles)<MapInfo.MapHeader.Ny)
          dir|=dirDown;
        if (dir) {
          RotateDirLeft (&dir);
          MoveMap (dir);
        } else {
          // applying ZOOM action
          // ZOOM action
          LoadZoom (1, event->screenX, event->screenY);
        }
        handled=true;
        break;
      } else {
        // point selection on all LCD area
        // other action
        ShowPoint (event->screenX, event->screenY, 0);
        px=MapInfo.curr_map.startX*MapInfo.MapHeader.Wx+(event->screenX*LCD.density)/kDensityLow;
        py=MapInfo.curr_map.startY*MapInfo.MapHeader.Wy+(event->screenY*LCD.density)/kDensityLow;
        switch (selectPoint) {
          case point_POI:
            DistanceWindow (false);
            // set actual position
            StrCopy (POI.fileinfo.name, MapInfo.curr_map.name);
            POI.fileinfo.volRefNum=MapInfo.curr_map.volRefNum;
            POI.fileinfo.startX=px;
            POI.fileinfo.startY=py;
            *POI.name=0;
            selectPoint=pointNone;
            // show dialog for entering POI's name
            dfrm=FrmInitForm (addPOI_form);
            i=FrmDoDialog (dfrm);
            hndl=FldGetTextHandle (FrmGetObjectPtr (dfrm, FrmGetObjectIndex (dfrm, POI_name)));
            if (hndl) {
              StrCopy (POI.name, MemHandleLock (hndl));
              MemHandleUnlock (hndl);
            }            
            FrmDeleteForm (dfrm);
            if (i!=POI_OK) break;
            // save new POI to database
            i=dmMaxRecordIndex;
            hndl=DmNewRecord (POI_DB, &i, sizeof (POI));
            if (!hndl) break;
            DmWrite (MemHandleLock (hndl), 0, &POI, sizeof (POI));
            MemHandleUnlock (hndl);
            DmReleaseRecord (POI_DB, i, true);
            break;
          case point_AzDi:
            DistanceWindow (false);
            selectPoint=pointNone;
            GridSetupInit ();
            if (FrmCustomResponseAlert (AzimuthDistance, Prefs.str[gridunit], "", "", fls, 32, NULL)) break;
            // zpracovani zadaneho textu
            //DEBUG ("New pos: %s", fls);
            str=fls;
            str+=SkipSpaces (fls);
            str+=GetFloat (str, &azimuth);
            while (*str && (*str<=' ' || *str==',')) str++;
            GetFloat (str, &distance);
/**
            GPSpos.lat.d=azimuth;
            GPSpos.lon.d=distance;
            FlpFToA (GPSpos.lat.fd, fls);
            StrCat (fls, " @ ");
            FlpFToA (GPSpos.lon.fd, &fls[StrLen (fls)]);
            // nova poloha bodu
            DEBUG ("point: %ld %ld + %s", px, py, fls);
**/
            // prepocteni na pixely a radiany
#define M_PI		3.14159265358979323846
            if (MapInfo.gridX.measure && MapInfo.gridX.pixels) {
              distance/=MapInfo.gridX.measure;
              distance*=MapInfo.gridX.pixels;
            }
            azimuth*=M_PI/180;
            // nova poloha bodu
            px+=sin(azimuth)*distance;
            py+=cos(azimuth)*(-distance);
/**
            // kontrolni zobrazeni mezivysledku
            GPSpos.lat.d=azimuth;
            GPSpos.lon.d=distance;
            FlpFToA (GPSpos.lat.fd, fls);
            StrCat (fls, " @ ");
            FlpFToA (GPSpos.lon.fd, &fls[StrLen (fls)]);
            DEBUG ("point: %ld %ld : %s", px, py, fls);
**/
            // poloha mapy
            MapInfo.curr_map.startX=px/MapInfo.MapHeader.Wx-MapInfo.Xtiles/2;
            MapInfo.curr_map.startY=py/MapInfo.MapHeader.Wy-MapInfo.Ytiles/2;
            if (MapInfo.curr_map.startX<0) MapInfo.curr_map.startX=0;
            if (MapInfo.curr_map.startY<0) MapInfo.curr_map.startY=0;
            ShowBitmaps (0, 0, MapInfo.curr_map.startX, MapInfo.curr_map.startY, MapInfo.Xtiles, MapInfo.Ytiles);
            // zobrazeni bodu
            ShowPoint (((px-MapInfo.curr_map.startX*MapInfo.MapHeader.Wx)*kDensityLow)/LCD.density, ((py-MapInfo.curr_map.startY*MapInfo.MapHeader.Wy)*kDensityLow)/LCD.density, 0);
            break;
          case point1:
            StrCopy (Prefs.str[coordmap], MapInfo.curr_map.name);
            Prefs.bin.coord1X=Prefs.bin.coord2X=px;
            Prefs.bin.coord1Y=Prefs.bin.coord2Y=py;
            selectPoint=point2;
            break;
          case point2:
            if (StrCaselessCompare (Prefs.str[coordmap], MapInfo.curr_map.name)) {
              if (FrmAlert (distanceWarning))
                break;
              GridSetupInit ();
              StrCopy (Prefs.str[coordmap], MapInfo.curr_map.name);
              Prefs.bin.coord1X=Prefs.bin.coord2X=px;
              Prefs.bin.coord1Y=Prefs.bin.coord2Y=py;
            } else {
              // adding distance from previous point2
              Prefs.bin.distance+=ComputeDistance (Prefs.bin.coord2X, Prefs.bin.coord2Y, px, py);
              // assign selected point as last point
              Prefs.bin.coord2X=px;
              Prefs.bin.coord2Y=py;
            }
            RedrawDistance ();
            break;
          default:
            selectPoint=pointNone;
            break;
        }
        handled=true;
        break;
      }
      break;
// ==== User events ====
    case mapMoveLeft:
      //MoveMap (DirRotate[LCD.rotate]);
      MoveMap (dirLeft);
      handled=true;
      break;
    case mapMoveRight:
      //MoveMap (DirRotate[LCD.rotate+2]);
      MoveMap (dirRight);
      handled=true;
      break;
    case mapMoveUp:
      //MoveMap (DirRotate[LCD.rotate+3]);
      MoveMap (dirUp);
      handled=true;
      break;
    case mapMoveDown:
      //MoveMap (DirRotate[LCD.rotate+1]);
      MoveMap (dirDown);
      handled=true;
      break;
    case mapCenter:
      MapInfo.curr_map.startX=MapInfo.MapHeader.size_x/MapInfo.MapHeader.Wx/2-MapInfo.Xtiles/2;
      MapInfo.curr_map.startY=MapInfo.MapHeader.size_y/MapInfo.MapHeader.Wy/2-MapInfo.Ytiles/2;
      if (MapInfo.curr_map.startX<0) MapInfo.curr_map.startX=0;
      if (MapInfo.curr_map.startY<0) MapInfo.curr_map.startY=0;
      ShowBitmaps (0, 0, MapInfo.curr_map.startX, MapInfo.curr_map.startY, MapInfo.Xtiles, MapInfo.Ytiles);
      if (selectPoint!=pointNone) DistanceWindow (true);
      handled=true;
      break;
    case mapOverview:
      SaveHistory ();
      // look for mapname to get volRefNum
      j=SearchMap (Prefs.str[overviewmap]);
      if (j==-1) break; // alert should be here...
      // check if mapname changed...
      i=StrCaselessCompare (MapInfo.curr_map.name, Prefs.str[overviewmap]);
      if (i) {
        StrCopy (MapInfo.curr_map.name, Prefs.str[overviewmap]);
        MapInfo.curr_map.volRefNum=VFSInfo.maplist[j]->volRefNum;
      }
      MapInfo.rel_pos_x=MapInfo.rel_pos_y=0.5;
      LoadMapFile (posSetRel);
      // draw map
      ShowBitmaps (0, 0, MapInfo.curr_map.startX, MapInfo.curr_map.startY, MapInfo.Xtiles, MapInfo.Ytiles);
      if (selectPoint!=pointNone) DistanceWindow (true);
      if (i)
        InsertHistory ();
      handled=true;
      break;
    case mapTop:
      LoadZoom (-2, 80, 80);
      handled=true;
      break;
    case mapPOI:
      handled=true;
      // make list of all POIs
      if (!POI_DB) break;
      if (!(hcnt=DmNumRecords (POI_DB))) break;
      hlist=MemPtrNew (hcnt*sizeof (Char*));
      if (hlist==NULL) break;
#ifdef CopyNames
      hlist[0]=MemPtrNew (hcnt*256);
#endif
      // loading POI names
      //it is not needed to make new space - fill pointers only!
      // and change it while showing history too ???
      for (i=0; i<hcnt; i++) {
        pptr=MemHandleLock(DmQueryRecord (POI_DB, i));
#ifdef CopyNames
        if (i) hlist[i]=&hlist[i-1][256];
        MemMove (hlist[i], pptr->name, 256);
#else
        hlist[i]=pptr->name;
#endif
        MemPtrUnlock (pptr);
      }
      // show list
      LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_hist)), hlist, hcnt);
      LstSetSelection (lst, 0);
      j=LstPopupList (lst);
      // free memory
#ifdef CopyNames
      MemPtrFree (hlist[0]);
#endif
      MemPtrFree (hlist);
      // if item selected
      if (j==-1) break;
      hndl=DmQueryRecord (POI_DB, j);
      if (!hndl) break;
      pptr=MemHandleLock (hndl);
      // save last visited map
      SaveHistory ();
      // reloading new map info
      i=MemPtrSize (pptr);
      if (i>sizeof (MapInfo.curr_map)) i=sizeof (MapInfo.curr_map);
      MemMove (&MapInfo.curr_map, &pptr->fileinfo, i);
      // recalculating pixels to tiles
      MapInfo.curr_map.startX=(MapInfo.curr_map.startX+MapInfo.MapHeader.Wx/2)/MapInfo.MapHeader.Wx-MapInfo.Xtiles/2;
      MapInfo.curr_map.startY=(MapInfo.curr_map.startY+MapInfo.MapHeader.Wy/2)/MapInfo.MapHeader.Wy-MapInfo.Ytiles/2;
      // load map file header and color table
      LoadMapFile (posCheck);
      // draw map
      ShowBitmaps (0, 0, MapInfo.curr_map.startX, MapInfo.curr_map.startY, MapInfo.Xtiles, MapInfo.Ytiles);
      if (selectPoint!=pointNone) DistanceWindow (true);
      // draw point
      ShowPoint (((pptr->fileinfo.startX-(MapInfo.curr_map.startX*MapInfo.MapHeader.Wx))*kDensityLow)/LCD.density, ((pptr->fileinfo.startY-(MapInfo.curr_map.startY*MapInfo.MapHeader.Wy))*kDensityLow)/LCD.density, 1);
      MemPtrUnlock (pptr);
      break;
    case mapZoomIn:
      LoadZoom (1, MapInfo.MapHeader.size_x>=LCD.actual.native.width?
        LCD.actual.standard.width/2:
        (LCD.actual.standard.width/2*MapInfo.MapHeader.size_x)/LCD.actual.native.width, 
        MapInfo.MapHeader.size_y>=LCD.actual.native.height?
        LCD.actual.standard.height/2:
        (LCD.actual.standard.height/2*MapInfo.MapHeader.size_y)/LCD.actual.native.height);
      handled=true;
      break;
    case mapZoomOut:
      LoadZoom (-1, LCD.actual.standard.width/2, LCD.actual.standard.height/2);
      handled=true;
      break;
    case mapOpen:
      handled=true;
      // immediate directory enumeMapInfo.ration
      while (!VFSInfo.DirectoryOK) GetDirEntry (-1);
      if (VFSInfo.openlist==NULL || !VFSInfo.mapcount) break;
      // looking for active map index
      for (j=0; j<VFSInfo.mapcount; j++) {
        if (!StrCaselessCompare (VFSInfo.maplist[j]->name, MapInfo.curr_map.name))
          break;
      }
      if (j>=VFSInfo.mapcount) j=-1;
      // reload openlist
      if (Prefs.bin.flags&Root_only) hcnt=0;
      for (VFSInfo.opencount=i=hcnt=0; i<VFSInfo.mapcount; i++) {
        if (VFSInfo.maplist[i]->flags&LinkFlag) continue;
        if (Prefs.bin.flags&Root_only) {
          if (!(VFSInfo.maplist[i]->flags&root_map)) continue;
          if (j>=0)
            if (VFSInfo.maplist[i]->index==VFSInfo.maplist[j]->index)
              hcnt=VFSInfo.opencount;
        } else {
          if (i==j) hcnt=VFSInfo.opencount;
        }
        VFSInfo.openlist[VFSInfo.opencount++]=VFSInfo.maplist[i]->name;
      }
      // make list with database's names
      LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_maps)), VFSInfo.openlist, VFSInfo.opencount);
      // select actual map
      LstSetSelection (lst, hcnt);
      LstSetTopItem (lst, hcnt);
      j=LstPopupList (lst);
      if (j==-1) break;
      // save current position to history DB
      SaveHistory ();
      // check if mapname changed...
      i=StrCaselessCompare (MapInfo.curr_map.name, VFSInfo.openlist[j]);
      // open map file
      StrCopy (MapInfo.curr_map.name, VFSInfo.openlist[j]);
      MapInfo.curr_map.volRefNum=*((UInt16*)(((UInt8*)VFSInfo.openlist[j])-(((UInt8*)VFSInfo.maplist[0]->name)-((UInt8*)&VFSInfo.maplist[0]->volRefNum))));
      // load map file header and color table
      if (Prefs.bin.flags&CartoonMode) 
        MapInfo.rel_pos_x=MapInfo.rel_pos_y=0;
      else
        MapInfo.rel_pos_x=MapInfo.rel_pos_y=0.5;
      LoadMapFile (posSetRel);
      // draw map
      ShowBitmaps (0, 0, MapInfo.curr_map.startX, MapInfo.curr_map.startY, MapInfo.Xtiles, MapInfo.Ytiles);
      if (selectPoint!=pointNone) DistanceWindow (true);
      // make new history entry
      if (i)
        InsertHistory ();
      break;
    case mapHistory:
      handled=true;
      // making history list
      if (!histDB) break;
      CleanUpHistory ();
      if (!(hcnt=DmNumRecords (histDB))) break;
      hlist=MemPtrNew (hcnt*sizeof (Char*));
      if (hlist==NULL) break;
#ifdef CopyNames
      hlist[0]=MemPtrNew (hcnt*256);
#endif
      // loading history names - w/o current map
      for (i=0; i<hcnt; i++) {
        hptr=MemHandleLock(DmQueryRecord (histDB, i));
#ifdef CopyNames
        if (i) hlist[i]=&hlist[i-1][256];
        MemMove (hlist[i], hptr->name, 256);
#else
        hlist[i]=hptr->name;
#endif
        MemPtrUnlock (hptr);
      }
      // drawing history list
      LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_hist)), hlist, hcnt);
      LstSetSelection (lst, 1);
      j=LstPopupList (lst);
      // free memory
#ifdef CopyNames
      MemPtrFree (hlist[0]);
#endif
      MemPtrFree (hlist);
      if (j==-1) break;
      // save current position to history DB
      SaveHistory ();
      // move selected record at current position
      DmMoveRecord (histDB, j, 0);
      // reloading new map info
      hptr=MemHandleLock(DmQueryRecord (histDB, 0));
      i=MemPtrSize (hptr);
      if (i>sizeof (MapInfo.curr_map)) i=sizeof (MapInfo.curr_map);
      MemMove (&MapInfo.curr_map, hptr, i);
      MemPtrUnlock (hptr);
      // load map file header and color table
      LoadMapFile (posCheck);
      // draw map
      ShowBitmaps (0, 0, MapInfo.curr_map.startX, MapInfo.curr_map.startY, MapInfo.Xtiles, MapInfo.Ytiles);
      if (selectPoint!=pointNone) DistanceWindow (true);
      break;
    case mapSetPoint1:
      if (selectPoint!=pointNone) DistanceWindow (false);
      selectPoint=(selectPoint==pointNone)?point1:pointNone;
      if (selectPoint==pointNone) break;
      // point init
      GridSetupInit ();
      Prefs.bin.coord1X=Prefs.bin.coord2X=MapInfo.curr_map.startX*MapInfo.MapHeader.Wx+LCD.actual.native.width/2;
      Prefs.bin.coord1Y=Prefs.bin.coord2Y=MapInfo.curr_map.startY*MapInfo.MapHeader.Wy+LCD.actual.native.height/2;
      DistanceWindow (true);
      handled=true;
      break;  
    case mapAddPoint2:
      if (selectPoint!=pointNone) DistanceWindow (false);
      selectPoint=(selectPoint==pointNone)?point2:pointNone;
      if (selectPoint==pointNone) break;
      DistanceWindow (true);
      handled=true;
      break;
    case mapDistances:
      ShowDistances ();
      handled=true;
      break;
    case mapRotateL:
      LCD.rotate-=2;
    case mapRotateR:
      LCD.rotate++;
      LCD.rotate&=0x03;
      Prefs.bin.flags&=~RotMask;
      Prefs.bin.flags|=(((UInt32)LCD.rotate)<<RotBits)&RotMask;
      CalcRotatedVars ();
      ShowBitmaps (0, 0, MapInfo.curr_map.startX, MapInfo.curr_map.startY, MapInfo.Xtiles, MapInfo.Ytiles);
      break;
    case mapGrid:
      Prefs.bin.flags^=Grid_mask;
      if (MapInfo.gridX.pixels || MapInfo.gridY.pixels) {
        ShowBitmaps (0, 0, MapInfo.curr_map.startX, MapInfo.curr_map.startY, MapInfo.Xtiles, MapInfo.Ytiles);
        if (selectPoint!=pointNone) DistanceWindow (true);
      }
      handled=true;
      break;
    case mapInfo:
      MapInfoAlert ();
      handled=true;
      break;
    case sysBackLight:
      //[127,163]+[11,19]
      if (LCD.resize) {
        event->eType=keyDownEvent;
        event->data.keyDown.chr=vchrBacklight;
        event->data.keyDown.modifiers=0;
        EvtAddEventToQueue (event);
      } else {
        // this tap is here for my SilkDimmer version (w/o sysNotifyEventDequeuedEvent - it uses sysNotifyProcessPenStrokeEvent)
        TapPoint (136,170);
      }
      handled=true;
      break;
    case sysMenu:
      //center:[14,204]
      if (LCD.resize) {
        event->eType=keyDownEvent;
        event->data.keyDown.chr=vchrMenu;
        event->data.keyDown.modifiers=0;
        EvtAddEventToQueue (event);
      } else {
        TapPoint (14,204);
      }
      handled=true;
      break;
    default:
      break;
  }
  return handled;
}
// ------------------------------------
// draw filled rectangle with selected grid color
// ------------------------------------
// GC_X 80
#define GC_X    64
#define GC_Y    42
void ShowGridColor (Int16 x, Int16 y, Int16 dx, Int16 dy, RGBColorType *rgb) {
RectangleType rect;

  rect.topLeft.x=x;
  rect.topLeft.y=y;
  rect.extent.x=dx;
  rect.extent.y=dy;
  WinSetForeColor (LCD.grid=WinRGBToIndex (rgb));
//  WinFillRectangle (&rect, 0);
  WinPaintRectangle (&rect, 0);
}
// ------------------------------------
// draw checkbox list for selecting icons to be used
// ------------------------------------
void DrawIconsList (Int16 itemNum, RectangleType *bounds, Char **itemsText) {
Int16 wd;

  FntSetFont (4);
  WinDrawChar ((Prefs.bin.cmd_icons&(1<<itemNum))?'\1':'\0', bounds->topLeft.x, bounds->topLeft.y);
  wd=FntCharWidth ('\1')+2;
  FntSetFont (stdFont);
  WinDrawChars (itemsText[itemNum], StrLen (itemsText[itemNum]), bounds->topLeft.x+wd, bounds->topLeft.y);
}
// ------------------------------------
// setup form handler
// ------------------------------------
static Boolean SetupFormHandler (EventPtr event) {
FormPtr         frm;
Boolean         handled;
Char		*edt_str;
Int16           sel;
ListPtr         lst;

  frm = FrmGetActiveForm ();
  handled=false;
  switch (event->eType) {
    case frmOpenEvent:
      oldflags=Prefs.bin.flags;
      if (Prefs.bin.flags&Root_only)
        CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, setup_rootmap)), 1);
      if (Prefs.bin.flags&CartoonMode)
        CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, setup_cartoon)), 1);
      LstSetSelection (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_colors)), sel=(Prefs.bin.flags&ColMask)>>ColBits);
      CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, trig_colors)), LstGetSelectionText (lst, sel));
//      LstSetSelection (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_rot)), sel=(Prefs.bin.flags&RotMask)>>RotBits);
//      CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, trig_rot)), LstGetSelectionText (lst, sel));
      LstSetDrawFunction (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_icons)), DrawIconsList);
      FldInsert (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, setup_dir)), Prefs.str[homedir], StrLen (Prefs.str[homedir]));
      FldInsert (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, setup_home)), Prefs.str[overviewmap], StrLen (Prefs.str[overviewmap]));
      FrmDrawForm (frm);
      // redraw selected color box
      ShowGridColor (GC_X, GC_Y, 12, 12, &Prefs.bin.gridCol);
      handled=true;
      break;
    case popSelectEvent:
      switch (event->data.popSelect.listID) {
        case list_buttons:
          // show function for selected button
          //if (event->data.popSelect.selection>btn_count) break;
          sel=LstGetNumberOfItems (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_function)));
          if (Prefs.bin.buttons[event->data.popSelect.selection]>=sel) Prefs.bin.buttons[event->data.popSelect.selection]=0;
          CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, trig_function)), LstGetSelectionText (lst, Prefs.bin.buttons[event->data.popSelect.selection]));
          break;
        case list_function:
          // save selected function
          sel=LstGetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_buttons)));
          if (sel!=noListSelection)
            Prefs.bin.buttons[sel]=event->data.popSelect.selection;
          break;
        case list_icons:
          Prefs.bin.cmd_icons^=1<<event->data.popSelect.selection;
          //...???
          // redraw item
          // to avoid closing list return true...
          handled=true;
          break;
      }
      break;
    case ctlSelectEvent:
      switch (event->data.ctlSelect.controlID) {
        case setup_OK:
          // controls setup
          Prefs.bin.flags&=0xFFFF0000;
          if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, setup_rootmap)))) 
	    Prefs.bin.flags|=Root_only;
          if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, setup_cartoon)))) 
	    Prefs.bin.flags|=CartoonMode;
	  sel=LstGetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_colors)));
	  if (sel!=noListSelection) Prefs.bin.flags|=(sel<<ColBits)&ColMask;
//	  sel=LstGetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_rot)));
//	  if (sel!=noListSelection) Prefs.bin.flags|=(sel<<RotBits)&RotMask;
	  edt_str=FldGetTextPtr (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, setup_dir)));
	  if (edt_str!=NULL) 
	    StrCopy (Prefs.str[homedir], edt_str);
	  edt_str=FldGetTextPtr (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, setup_home)));
	  if (edt_str!=NULL) 
	    StrCopy (Prefs.str[overviewmap], edt_str);
          FrmGotoForm (view_form);
          break;
        case grid_color:
          if (!UIPickColor (NULL, &Prefs.bin.gridCol, UIPickColorStartPalette, "Grid color", NULL)) break;
          // redraw selected color box
          ShowGridColor (GC_X, GC_Y, 12, 12, &Prefs.bin.gridCol);
          break;
	default:
	  break;
      }
      break;
    default:
      break;
  }
  
  return handled;
}
// ====================================
// basic functions
// ------------------------------------
// checking/creating database
// ------------------------------------
DmOpenRef CheckCreateDatabase (Char *name, UInt32 type) {
LocalID locid;
UInt16  card, attr;
  SysCurAppDatabase (&card, &locid);
  locid=DmFindDatabase (card, name);
  if (!locid) {
    if (DmCreateDatabase (card, name, AppID, type, false)!=errNone) return 0;
    locid=DmFindDatabase (card, name);
    if (!locid) return 0;
    DmDatabaseInfo (card, locid, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
    attr|=dmHdrAttrBackup;
    DmSetDatabaseInfo (card, locid, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
  }
  return DmOpenDatabase (card, locid, dmModeReadWrite);
}
// ------------------------------------
// startup setup
// ------------------------------------
static Err StartApplication(void) {
UInt32          version;
Err             err;
UInt16          idx, idx2;
UInt16	        size;
MemHandle       dataHndl;

  // initializing multi-variables
  MemSet (&LCD, sizeof (LCD), 0);
  LCD.bits=1;
  LCD.sonyHiResRefNum=sysInvalidRefNum;
  LCD.systemPalette=true;

  MemSet (&VFSInfo, sizeof (VFSInfo), 0);
  VFSInfo.dirIterator=VFSInfo.volIterator=vfsIteratorStart;

  MemSet (&MapInfo, sizeof (MapInfo), 0);
  MapInfo.Xtiles=MapInfo.Ytiles=2;
  MapInfo.MapHeader.Wx=MapInfo.MapHeader.Wy=80;

  MemSet (&DrawInfo, sizeof (DrawInfo), 0);
  DrawInfo.ZLibRefNum=sysInvalidRefNum;

  // initializing other variables
  histDB=0;
  hardEnable=0;
  win_dist=NULL;

  // opening MathLib
  err = SysLibFind(MathLibName, &MathLibRef);
  if (err)
    err = SysLibLoad(LibType, MathLibCreator, &MathLibRef);
  //ErrFatalDisplayIf(error, "Can't find MathLib"); // Just an example; handle it gracefully
  if (err) return cannotRunApp;
  err = MathLibOpen(MathLibRef, MathLibVersion);
  //ErrFatalDisplayIf(error, "Can't open MathLib"); 
  if (err) return cannotRunApp;
  
  // check for OS >=4.0 (VFS support)
  version=0;
  err = FtrGet (sysFtrCreator, sysFtrNumROMVersion, &version);
  if (version<0x04003000)
    return cannotRunApp;
  // check for Expansion Manager
  err = FtrGet (sysFileCExpansionMgr, expFtrIDVersion, &version);
  if (err)
    return cannotRunApp;
  // check for VFS Manager
  err = FtrGet (sysFileCVFSMgr, vfsFtrIDVersion, &version);
  if (err)
    return cannotRunApp;

  // LCD mode
  WinScreenMode (winScreenModeGet, &LCD.device.native.width, &LCD.device.native.height, &LCD.bits, NULL); // load all current parameters
  // LoRes/HiRes init
  version=0;
  LCD.density=kDensityLow;
  err = FtrGet(sysFtrCreator, sysFtrNumWinVersion, &version);
  // Sony HiRes
  err=SysLibFind (sonySysLibNameHR, &LCD.sonyHiResRefNum);
  if (err==sysErrLibNotFound)
    err=SysLibLoad ('libr', sonySysFileCHRLib, &LCD.sonyHiResRefNum);
  if (err==errNone)
    err=HROpen (LCD.sonyHiResRefNum);
  if (err==errNone) { // SONY HiRes device
    LCD.density=kDensityDouble;
    LCD.device.native.width=hrWidth;
    LCD.device.native.height=hrHeight;
    HRWinScreenMode (LCD.sonyHiResRefNum, winScreenModeSet, &LCD.device.native.width, &LCD.device.native.height, NULL, NULL);
  }
  // OS5 HiRes
  if (version>=4) {
    if (LCD.sonyHiResRefNum==sysInvalidRefNum) {
      WinScreenGetAttribute (winScreenDensity, &LCD.density);
      WinScreenGetAttribute (winScreenWidth, &LCD.device.native.width);
      WinScreenGetAttribute (winScreenHeight, &LCD.device.native.height);
      //WinSetCoordinateSystem (LCD.density);
    }
  }
  // retrieving bits-per-pixel color depths
  if (LCD.sonyHiResRefNum==sysInvalidRefNum)
    WinScreenMode (winScreenModeGetSupportedDepths, NULL, NULL, &LCD.modes, NULL); // load available color depths
  else
    HRWinScreenMode (LCD.sonyHiResRefNum, winScreenModeGetSupportedDepths, NULL, NULL, &LCD.modes, NULL); // load available color depths
  // setting default color depth
  SetLCDmode (8);

  // It seems that there is some error in handling kDensityNative!
  // alerts are drawn so that no button is visible (buttons are hidden under bottom LCD edge...)
  // can't use full-time HiRes mode... :-(
//  if (LCD.density!=kDensityLow && LCD.sonyHiResRefNum==sysInvalidRefNum)
//    WinSetCoordinateSystem (kCoordinatesNative);

  // checking for DIA / PIN
  if (LCD.device.native.width!=LCD.device.native.height) {
    err=FtrGet (pinCreator, pinFtrAPIVersion, &version);
    if (!err && version>=0x01100000) {
      LCD.resize=true;
      // obtaining size of control bar
      StatGetAttribute (statAttrDimension, &version);
      // Simulator returns 00A0000F as expected (first UInt16 is width)
      // T5 returns 000E00A0; it seems that there is an error confusing LSB vs. MSB order...
      // so I get the smaller value...
      if (((version>>16)&0xFFFF)<(version&0xFFFF)) version>>=16;
      // or I can get processor ID
      // FtrGet (sysFtrCreator, sysFtrNumProcessorID, &id);
      // if ((id&sysFtrNumProcessorMask)==sysFtrNumProcessorx86) // running in simulator...?
      LCD.form.native.height-=((version&0x0000FFFFL)*LCD.density)/kDensityLow;
      // let DIA trigger on while support is done
      //PINSetInputTriggerState (pinInputTriggerDisabled);
      // let orientation trigger on while resizing support is done...
      //SysSetOrientationTriggerState (sysOrientationTriggerDisabled);
//    } else {
//      LCD.form.native.width=LCD.form.native.height=(LCD.form.native.width<LCD.form.native.height)?LCD.form.native.width:LCD.form.native.height;
    }
  }
  // calculating lores size
  LCD.device.standard.width=(LCD.device.native.width*kDensityLow)/LCD.density;
  LCD.device.standard.height=(LCD.device.native.height*kDensityLow)/LCD.density;
  // copying LCD size to LCD.form
  MemMove (&LCD.form, &LCD.device, sizeof (LCD.form));
  // trimming display sizes to square shape
  LCD.form.native.width=LCD.form.native.height=(LCD.form.native.width<LCD.form.native.height)?LCD.form.native.width:LCD.form.native.height;

  // opening ZLib library
  SysZLib_OpenLibrary (&DrawInfo.ZLibRefNum);

  // loading preferences
  idx=0;
  if (PrefGetAppPreferences (AppID, 0, NULL, &idx, true)!=noPreferenceFound) {
    if (idx>sizeof (Prefs.bin)) idx=sizeof (Prefs.bin);
    PrefGetAppPreferences (AppID, 0, &Prefs.bin, &idx, true);
  }
  for (idx2=0; idx2<prefstrcnt; idx2++) {
    idx=0;
    if (idx2!=homedir)
      *Prefs.str[idx2]=0;
    if (PrefGetAppPreferences (AppID, idx2+1, NULL, &idx, true)!=noPreferenceFound) {
      if (idx>256) idx=256;
      PrefGetAppPreferences (AppID, idx2+1, Prefs.str[idx2], &idx, true);
    }
    Prefs.str[idx2][255]=0;
  }
  oldflags=Prefs.bin.flags;
  // loading history
  histDB=CheckCreateDatabase ("MapViewHistory", HistID);
  if (!histDB) return cannotCreateHistoryDB;
  if (!DmNumRecords (histDB)) {
    // create empty record
    size=0;
    dataHndl=DmNewRecord (histDB, &size, sizeof (historyType));
    if (!dataHndl) return cannotCreateHistoryDB;
    DmSet (MemHandleLock (dataHndl), 0, sizeof (historyType), 0);
    MemHandleUnlock (dataHndl);
    DmReleaseRecord (histDB, size, true);
  }
  dataHndl=DmQueryRecord (histDB, 0);
  if (!dataHndl) return cannotReadHistoryDB;
  MemMove (&MapInfo.curr_map, MemHandleLock (dataHndl), MemHandleSize (dataHndl));
  MemHandleUnlock (dataHndl);
  // loading POI database
  POI_DB=CheckCreateDatabase ("MapView_POI", POI_ID);
  if (!POI_DB) return cannotCreateHistoryDB;

  // preparing directory enumeration
  VFSInfo.maplist=MemPtrNew (MaxDIRentries*sizeof (direntry*));
  if (VFSInfo.maplist==NULL) return memoryError;
  for (idx=0; idx<MaxDIRentries; idx++)
    VFSInfo.maplist[idx]=NULL;

  // load last mapfile
  LoadMapFile (posCheck);
  if (!MapInfo.valid)
    if(FrmCustomAlert(frm_about,SW_VERSION,build,""))
      FrmHelp (str_about);

  return 0;
}
// ------------------------------------
// exit cleanup
// ------------------------------------
static void StopApplication (Err code) {
Int16           i;
Err             err;

  // freeing memory
  if (VFSInfo.DIRref) VFSFileClose (VFSInfo.DIRref);
  if (DrawInfo.bitmap!=NULL) BmpDelete (DrawInfo.bitmap);
  if (DrawInfo.oldbmp!=NULL) BmpDelete (DrawInfo.oldbmp);
  if (VFSInfo.openlist!=NULL) MemPtrFree (VFSInfo.openlist);
  if (VFSInfo.maplist!=NULL) {
    for (i=0; i<VFSInfo.mapcount; i++)
      if (VFSInfo.maplist[i]!=NULL)
        MemPtrFree (VFSInfo.maplist[i]);
    MemPtrFree (VFSInfo.maplist);
  }
  if (DrawInfo.zip_data!=NULL) MemPtrFree (DrawInfo.zip_data);
  if (MapInfo.GPScal) MemPtrFree (MapInfo.GPScal);
  // switching off Sony HiRes
  if (LCD.sonyHiResRefNum!=sysInvalidRefNum) {
    HRWinScreenMode (LCD.sonyHiResRefNum, winScreenModeSetToDefaults, NULL, NULL, NULL, NULL);
    HRClose (LCD.sonyHiResRefNum);
  }
  // closing MathLib
  err = MathLibClose(MathLibRef, &i);
  //ErrFatalDisplayIf(error, "Can't close MathLib");
  //if (usecount == 0)
  if (!err && !i)
    SysLibRemove(MathLibRef); 
  // closing ZLib
  if (DrawInfo.ZLibRefNum!=sysInvalidRefNum)
    SysZLib_CloseLibrary (DrawInfo.ZLibRefNum);
  // saving preferences
  PrefSetAppPreferences (AppID, 0, 0, &Prefs.bin, sizeof (Prefs.bin), true);
  for (i=0; i<prefstrcnt; i++)
    PrefSetAppPreferences (AppID, i+1, 0, Prefs.str[i], StrLen (Prefs.str[i])+1, true);
  // saving history
  if (histDB) {
    SaveHistory ();
    // closing history file
    DmCloseDatabase (histDB);
  }
  if (POI_DB)
    DmCloseDatabase (POI_DB);
}
// ------------------------------------
// event loop
// ------------------------------------
static void EventLoop(void) {
FormPtr         form;
EventType       event;
UInt16          err;

  do {
    EvtGetEvent (&event, (VFSInfo.DirectoryOK)?evtWaitForever:1);
    if (!VFSInfo.DirectoryOK && event.eType==nilEvent) {
      GetDirEntry (1);
      continue;
    }
    if (event.eType==keyDownEvent && hardEnable)
      if (FrmDispatchEvent (&event)) continue;
    if (SysHandleEvent (&event)) continue;
    if (MenuHandleEvent (NULL, &event, &err)) continue;
    if (event.eType == frmLoadEvent) {
      FrmSetActiveForm (form=FrmInitForm (event.data.frmLoad.formID));
      switch (event.data.frmLoad.formID) {
	case view_form:
	  FrmSetEventHandler (form, (FormEventHandlerPtr) ViewMapFormHandler);
	  break;
        case setup_form:
	  FrmSetEventHandler (form, (FormEventHandlerPtr) SetupFormHandler);
	  break;
/***
	case info_form:
	  FrmSetEventHandler (form, (FormEventHandlerPtr) InfoFormHandler);
	  break;
***/
      }
    }
    if (event.eType!=keyDownEvent || !hardEnable)
      if (FrmDispatchEvent (&event)) continue;
  } while (event.eType != appStopEvent);
  FrmCloseAllForms ();
}
// ------------------------------------
// entry point
// ------------------------------------
UInt32  PilotMain (UInt16 cmd, void *cmdPBP, UInt16 launchFlags) {
Err error;

  if (cmd!=sysAppLaunchCmdNormalLaunch)
    return 0;

  // application start-up part
  if ((error=StartApplication ())) {
    FrmAlert (error);
    StopApplication (error);
    return error;
  }
  // display main form
  FrmGotoForm (view_form);
//  FrmGotoForm (setup_form);
  // event loop
  EventLoop ();
  // application end routine
  StopApplication (0);
  return 0;
}
